/* sudoku-board.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libsudoku.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib-object.h>
#include <qqwing-wrapper.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SUDOKU_BOARD_0_PROPERTY,
	SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY,
	SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY,
	SUDOKU_BOARD_BLOCK_ROWS_PROPERTY,
	SUDOKU_BOARD_BLOCK_COLS_PROPERTY,
	SUDOKU_BOARD_ROWS_PROPERTY,
	SUDOKU_BOARD_COLS_PROPERTY,
	SUDOKU_BOARD_MAX_VAL_PROPERTY,
	SUDOKU_BOARD_BROKEN_PROPERTY,
	SUDOKU_BOARD_FILLED_PROPERTY,
	SUDOKU_BOARD_FIXED_PROPERTY,
	SUDOKU_BOARD_SIZE_PROPERTY,
	SUDOKU_BOARD_COMPLETE_PROPERTY,
	SUDOKU_BOARD_BROKEN_COORDS_PROPERTY,
	SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY,
	SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY,
	SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY,
	SUDOKU_BOARD_NUM_PROPERTIES
};
static GParamSpec* sudoku_board_properties[SUDOKU_BOARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _coord_free0(var) ((var == NULL) ? NULL : (var = (coord_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SUDOKU_BOARD_COMPLETED_SIGNAL,
	SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL,
	SUDOKU_BOARD_CELL_CHANGED_SIGNAL,
	SUDOKU_BOARD_NUM_SIGNALS
};
static guint sudoku_board_signals[SUDOKU_BOARD_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuBoardPrivate {
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gint* solution;
	gint solution_length1;
	gint solution_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	gint* occurences_in_row;
	gint occurences_in_row_length1;
	gint occurences_in_row_length2;
	gint* occurences_in_col;
	gint occurences_in_col_length1;
	gint occurences_in_col_length2;
	gint* occurences_in_block;
	gint occurences_in_block_length1;
	gint occurences_in_block_length2;
	gint occurences_in_block_length3;
	gboolean* earmarks;
	gint earmarks_length1;
	gint earmarks_length2;
	gint earmarks_length3;
	gint n_earmarks;
	gdouble _previous_played_time;
	DifficultyCategory _difficulty_category;
	gint _block_rows;
	gint _block_cols;
	gint _rows;
	gint _cols;
	gint _filled;
	gint _fixed;
	GeeSet* _broken_coords;
	GeeList* _coords_for_col;
	GeeList* _coords_for_row;
	GeeMap* _coords_for_block;
};

static gint SudokuBoard_private_offset;
static gpointer sudoku_board_parent_class = NULL;

static void sudoku_board_set_fixed (SudokuBoard* self,
                             gint value);
static void sudoku_board_set_cols (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_rows (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_block_rows (SudokuBoard* self,
                                  gint value);
static void sudoku_board_set_block_cols (SudokuBoard* self,
                                  gint value);
static void sudoku_board_set_broken_coords (SudokuBoard* self,
                                     GeeSet* value);
static void sudoku_board_set_coords_for_col (SudokuBoard* self,
                                      GeeList* value);
static void sudoku_board_set_coords_for_row (SudokuBoard* self,
                                      GeeList* value);
static void sudoku_board_set_coords_for_block (SudokuBoard* self,
                                        GeeMap* value);
static gint* _vala_array_dup1 (gint* self,
                        gssize length);
static gint* _vala_array_dup2 (gint* self,
                        gssize length);
static gboolean* _vala_array_dup3 (gboolean* self,
                            gssize length);
static gint* _vala_array_dup4 (gint* self,
                        gssize length);
static gint* _vala_array_dup5 (gint* self,
                        gssize length);
static gint* _vala_array_dup6 (gint* self,
                        gssize length);
static void sudoku_board_set_filled (SudokuBoard* self,
                              gint value);
static gboolean* _vala_array_dup7 (gboolean* self,
                            gssize length);
static gint* _vala_array_dup8 (gint* self,
                        gssize length);
static void sudoku_board_update_old_breakages (SudokuBoard* self,
                                        gint row,
                                        gint col,
                                        gint val);
static void sudoku_board_mark_breakages (SudokuBoard* self,
                                  gint row,
                                  gint col,
                                  gint val);
static void sudoku_board_add_to_occurences (SudokuBoard* self,
                                     gint row,
                                     gint col,
                                     gint val,
                                     gint add);
static void sudoku_board_remove_breakages_for (SudokuBoard* self,
                                        GeeList* coords,
                                        gint val);
static void sudoku_board_mark_breakages_for (SudokuBoard* self,
                                      GeeList* coords,
                                      gint val);
static gint* sudoku_board_fixed_cells_only (SudokuBoard* self,
                                     gint* result_length1,
                                     gint* result_length2);
static gint* sudoku_board_convert_2d_to_1d (SudokuBoard* self,
                                     gint* ints_2d,
                                     gint ints_2d_length1,
                                     gint ints_2d_length2,
                                     gint* result_length1);
static gint* sudoku_board_convert_1d_to_2d (SudokuBoard* self,
                                     gint* ints_1d,
                                     gint ints_1d_length1,
                                     gint* result_length1,
                                     gint* result_length2);
static gint* _vala_array_dup9 (gint* self,
                        gssize length);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_BOOLEAN (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void sudoku_board_finalize (GObject * obj);
static GType sudoku_board_get_type_once (void);
static void _vala_sudoku_board_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sudoku_board_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sudoku_board_get_instance_private (SudokuBoard* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuBoard_private_offset);
}

void
sudoku_board_set_all_is_fixed (SudokuBoard* self)
{
#line 80 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 232 "sudoku-board.c"
	{
		gint r = 0;
#line 82 "../lib/sudoku-board.vala"
		r = 0;
#line 237 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 82 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 82 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 244 "sudoku-board.c"
				gint _tmp2_;
#line 82 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 248 "sudoku-board.c"
					gint _tmp1_;
#line 82 "../lib/sudoku-board.vala"
					_tmp1_ = r;
#line 82 "../lib/sudoku-board.vala"
					r = _tmp1_ + 1;
#line 254 "sudoku-board.c"
				}
#line 82 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 82 "../lib/sudoku-board.vala"
				_tmp2_ = self->priv->_rows;
#line 82 "../lib/sudoku-board.vala"
				if (!(r < _tmp2_)) {
#line 82 "../lib/sudoku-board.vala"
					break;
#line 264 "sudoku-board.c"
				}
				{
					gint c = 0;
#line 83 "../lib/sudoku-board.vala"
					c = 0;
#line 270 "sudoku-board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 83 "../lib/sudoku-board.vala"
						_tmp3_ = TRUE;
#line 83 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 277 "sudoku-board.c"
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
#line 83 "../lib/sudoku-board.vala"
							if (!_tmp3_) {
#line 285 "sudoku-board.c"
								gint _tmp4_;
#line 83 "../lib/sudoku-board.vala"
								_tmp4_ = c;
#line 83 "../lib/sudoku-board.vala"
								c = _tmp4_ + 1;
#line 291 "sudoku-board.c"
							}
#line 83 "../lib/sudoku-board.vala"
							_tmp3_ = FALSE;
#line 83 "../lib/sudoku-board.vala"
							_tmp5_ = self->priv->_cols;
#line 83 "../lib/sudoku-board.vala"
							if (!(c < _tmp5_)) {
#line 83 "../lib/sudoku-board.vala"
								break;
#line 301 "sudoku-board.c"
							}
#line 84 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->cells;
#line 84 "../lib/sudoku-board.vala"
							_tmp6__length1 = self->priv->cells_length1;
#line 84 "../lib/sudoku-board.vala"
							_tmp6__length2 = self->priv->cells_length2;
#line 84 "../lib/sudoku-board.vala"
							_tmp7_ = _tmp6_[(r * _tmp6__length2) + c];
#line 84 "../lib/sudoku-board.vala"
							if (_tmp7_ > 0) {
#line 313 "sudoku-board.c"
								gboolean* _tmp8_;
								gint _tmp8__length1;
								gint _tmp8__length2;
								gint _tmp9_;
#line 86 "../lib/sudoku-board.vala"
								_tmp8_ = self->priv->is_fixed;
#line 86 "../lib/sudoku-board.vala"
								_tmp8__length1 = self->priv->is_fixed_length1;
#line 86 "../lib/sudoku-board.vala"
								_tmp8__length2 = self->priv->is_fixed_length2;
#line 86 "../lib/sudoku-board.vala"
								_tmp8_[(r * _tmp8__length2) + c] = TRUE;
#line 87 "../lib/sudoku-board.vala"
								_tmp9_ = self->priv->_fixed;
#line 87 "../lib/sudoku-board.vala"
								sudoku_board_set_fixed (self, _tmp9_ + 1);
#line 330 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
}

gboolean
sudoku_board_is_empty (SudokuBoard* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 96 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 98 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_fixed;
#line 98 "../lib/sudoku-board.vala"
	if (_tmp1_ == _tmp2_) {
#line 98 "../lib/sudoku-board.vala"
		_tmp0_ = self->priv->n_earmarks == 0;
#line 357 "sudoku-board.c"
	} else {
#line 98 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 361 "sudoku-board.c"
	}
#line 98 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 98 "../lib/sudoku-board.vala"
	return result;
#line 367 "sudoku-board.c"
}

gboolean
sudoku_board_is_fully_filled (SudokuBoard* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 101 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 103 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_filled;
#line 103 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 103 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_rows;
#line 103 "../lib/sudoku-board.vala"
	result = _tmp0_ == (_tmp1_ * _tmp2_);
#line 103 "../lib/sudoku-board.vala"
	return result;
#line 389 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_construct (GType object_type,
                        gint block_rows,
                        gint block_cols)
{
	SudokuBoard * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint* _tmp11_;
	gint* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean* _tmp17_;
	GeeHashSet* _tmp37_;
	GeeHashSet* _tmp38_;
	GeeArrayList* _tmp39_;
	GeeArrayList* _tmp40_;
	GeeList* _tmp61_;
	GeeList* _tmp62_;
	GeeList* _tmp63_;
	GeeList* _tmp64_;
	GeeArrayList* _tmp65_;
	GeeArrayList* _tmp66_;
	GeeList* _tmp87_;
	GeeList* _tmp88_;
	GeeList* _tmp89_;
	GeeList* _tmp90_;
	GeeHashMap* _tmp91_;
	GeeHashMap* _tmp92_;
	GeeMap* _tmp125_;
	GeeMap* _tmp126_;
	GeeMap* _tmp127_;
	GeeMap* _tmp128_;
#line 122 "../lib/sudoku-board.vala"
	self = (SudokuBoard*) g_object_new (object_type, NULL);
#line 124 "../lib/sudoku-board.vala"
	sudoku_board_set_cols (self, block_rows * block_cols);
#line 124 "../lib/sudoku-board.vala"
	sudoku_board_set_rows (self, block_rows * block_cols);
#line 125 "../lib/sudoku-board.vala"
	sudoku_board_set_block_rows (self, block_rows);
#line 126 "../lib/sudoku-board.vala"
	sudoku_board_set_block_cols (self, block_cols);
#line 127 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 127 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 127 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 127 "../lib/sudoku-board.vala"
	self->priv->cells = (g_free (self->priv->cells), NULL);
#line 127 "../lib/sudoku-board.vala"
	self->priv->cells = _tmp2_;
#line 127 "../lib/sudoku-board.vala"
	self->priv->cells_length1 = _tmp0_;
#line 127 "../lib/sudoku-board.vala"
	self->priv->cells_length2 = _tmp1_;
#line 128 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 128 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->_cols;
#line 128 "../lib/sudoku-board.vala"
	_tmp5_ = g_new0 (gboolean, _tmp3_ * _tmp4_);
#line 128 "../lib/sudoku-board.vala"
	self->priv->is_fixed = (g_free (self->priv->is_fixed), NULL);
#line 128 "../lib/sudoku-board.vala"
	self->priv->is_fixed = _tmp5_;
#line 128 "../lib/sudoku-board.vala"
	self->priv->is_fixed_length1 = _tmp3_;
#line 128 "../lib/sudoku-board.vala"
	self->priv->is_fixed_length2 = _tmp4_;
#line 129 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->_rows;
#line 129 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->_cols;
#line 129 "../lib/sudoku-board.vala"
	_tmp8_ = g_new0 (gint, _tmp6_ * _tmp7_);
#line 129 "../lib/sudoku-board.vala"
	self->priv->occurences_in_row = (g_free (self->priv->occurences_in_row), NULL);
#line 129 "../lib/sudoku-board.vala"
	self->priv->occurences_in_row = _tmp8_;
#line 129 "../lib/sudoku-board.vala"
	self->priv->occurences_in_row_length1 = _tmp6_;
#line 129 "../lib/sudoku-board.vala"
	self->priv->occurences_in_row_length2 = _tmp7_;
#line 130 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->_cols;
#line 130 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->_rows;
#line 130 "../lib/sudoku-board.vala"
	_tmp11_ = g_new0 (gint, _tmp9_ * _tmp10_);
#line 130 "../lib/sudoku-board.vala"
	self->priv->occurences_in_col = (g_free (self->priv->occurences_in_col), NULL);
#line 130 "../lib/sudoku-board.vala"
	self->priv->occurences_in_col = _tmp11_;
#line 130 "../lib/sudoku-board.vala"
	self->priv->occurences_in_col_length1 = _tmp9_;
#line 130 "../lib/sudoku-board.vala"
	self->priv->occurences_in_col_length2 = _tmp10_;
#line 131 "../lib/sudoku-board.vala"
	_tmp12_ = g_new0 (gint, (block_rows * block_cols) * (block_rows * block_cols));
#line 131 "../lib/sudoku-board.vala"
	self->priv->occurences_in_block = (g_free (self->priv->occurences_in_block), NULL);
#line 131 "../lib/sudoku-board.vala"
	self->priv->occurences_in_block = _tmp12_;
#line 131 "../lib/sudoku-board.vala"
	self->priv->occurences_in_block_length1 = block_rows;
#line 131 "../lib/sudoku-board.vala"
	self->priv->occurences_in_block_length2 = block_cols;
#line 131 "../lib/sudoku-board.vala"
	self->priv->occurences_in_block_length3 = block_rows * block_cols;
#line 132 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->_rows;
#line 132 "../lib/sudoku-board.vala"
	_tmp14_ = self->priv->_cols;
#line 132 "../lib/sudoku-board.vala"
	_tmp15_ = sudoku_board_get_max_val (self);
#line 132 "../lib/sudoku-board.vala"
	_tmp16_ = _tmp15_;
#line 132 "../lib/sudoku-board.vala"
	_tmp17_ = g_new0 (gboolean, (_tmp13_ * _tmp14_) * _tmp16_);
#line 132 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 132 "../lib/sudoku-board.vala"
	self->priv->earmarks = _tmp17_;
#line 132 "../lib/sudoku-board.vala"
	self->priv->earmarks_length1 = _tmp13_;
#line 132 "../lib/sudoku-board.vala"
	self->priv->earmarks_length2 = _tmp14_;
#line 132 "../lib/sudoku-board.vala"
	self->priv->earmarks_length3 = _tmp16_;
#line 534 "sudoku-board.c"
	{
		gint l1 = 0;
#line 134 "../lib/sudoku-board.vala"
		l1 = 0;
#line 539 "sudoku-board.c"
		{
			gboolean _tmp18_ = FALSE;
#line 134 "../lib/sudoku-board.vala"
			_tmp18_ = TRUE;
#line 134 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 546 "sudoku-board.c"
				gint _tmp20_;
#line 134 "../lib/sudoku-board.vala"
				if (!_tmp18_) {
#line 550 "sudoku-board.c"
					gint _tmp19_;
#line 134 "../lib/sudoku-board.vala"
					_tmp19_ = l1;
#line 134 "../lib/sudoku-board.vala"
					l1 = _tmp19_ + 1;
#line 556 "sudoku-board.c"
				}
#line 134 "../lib/sudoku-board.vala"
				_tmp18_ = FALSE;
#line 134 "../lib/sudoku-board.vala"
				_tmp20_ = self->priv->_rows;
#line 134 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp20_)) {
#line 134 "../lib/sudoku-board.vala"
					break;
#line 566 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 136 "../lib/sudoku-board.vala"
					l2 = 0;
#line 572 "sudoku-board.c"
					{
						gboolean _tmp21_ = FALSE;
#line 136 "../lib/sudoku-board.vala"
						_tmp21_ = TRUE;
#line 136 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 579 "sudoku-board.c"
							gint _tmp23_;
							gint* _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							gboolean* _tmp25_;
							gint _tmp25__length1;
							gint _tmp25__length2;
							gint* _tmp26_;
							gint _tmp26__length1;
							gint _tmp26__length2;
							gint* _tmp27_;
							gint _tmp27__length1;
							gint _tmp27__length2;
#line 136 "../lib/sudoku-board.vala"
							if (!_tmp21_) {
#line 595 "sudoku-board.c"
								gint _tmp22_;
#line 136 "../lib/sudoku-board.vala"
								_tmp22_ = l2;
#line 136 "../lib/sudoku-board.vala"
								l2 = _tmp22_ + 1;
#line 601 "sudoku-board.c"
							}
#line 136 "../lib/sudoku-board.vala"
							_tmp21_ = FALSE;
#line 136 "../lib/sudoku-board.vala"
							_tmp23_ = self->priv->_cols;
#line 136 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp23_)) {
#line 136 "../lib/sudoku-board.vala"
								break;
#line 611 "sudoku-board.c"
							}
#line 138 "../lib/sudoku-board.vala"
							_tmp24_ = self->priv->cells;
#line 138 "../lib/sudoku-board.vala"
							_tmp24__length1 = self->priv->cells_length1;
#line 138 "../lib/sudoku-board.vala"
							_tmp24__length2 = self->priv->cells_length2;
#line 138 "../lib/sudoku-board.vala"
							_tmp24_[(l1 * _tmp24__length2) + l2] = 0;
#line 139 "../lib/sudoku-board.vala"
							_tmp25_ = self->priv->is_fixed;
#line 139 "../lib/sudoku-board.vala"
							_tmp25__length1 = self->priv->is_fixed_length1;
#line 139 "../lib/sudoku-board.vala"
							_tmp25__length2 = self->priv->is_fixed_length2;
#line 139 "../lib/sudoku-board.vala"
							_tmp25_[(l1 * _tmp25__length2) + l2] = FALSE;
#line 140 "../lib/sudoku-board.vala"
							_tmp26_ = self->priv->occurences_in_row;
#line 140 "../lib/sudoku-board.vala"
							_tmp26__length1 = self->priv->occurences_in_row_length1;
#line 140 "../lib/sudoku-board.vala"
							_tmp26__length2 = self->priv->occurences_in_row_length2;
#line 140 "../lib/sudoku-board.vala"
							_tmp26_[(l1 * _tmp26__length2) + l2] = 0;
#line 141 "../lib/sudoku-board.vala"
							_tmp27_ = self->priv->occurences_in_col;
#line 141 "../lib/sudoku-board.vala"
							_tmp27__length1 = self->priv->occurences_in_col_length1;
#line 141 "../lib/sudoku-board.vala"
							_tmp27__length2 = self->priv->occurences_in_col_length2;
#line 141 "../lib/sudoku-board.vala"
							_tmp27_[(l2 * _tmp27__length2) + l1] = 0;
#line 645 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint l1 = 0;
#line 144 "../lib/sudoku-board.vala"
		l1 = 0;
#line 656 "sudoku-board.c"
		{
			gboolean _tmp28_ = FALSE;
#line 144 "../lib/sudoku-board.vala"
			_tmp28_ = TRUE;
#line 144 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 144 "../lib/sudoku-board.vala"
				if (!_tmp28_) {
#line 665 "sudoku-board.c"
					gint _tmp29_;
#line 144 "../lib/sudoku-board.vala"
					_tmp29_ = l1;
#line 144 "../lib/sudoku-board.vala"
					l1 = _tmp29_ + 1;
#line 671 "sudoku-board.c"
				}
#line 144 "../lib/sudoku-board.vala"
				_tmp28_ = FALSE;
#line 144 "../lib/sudoku-board.vala"
				if (!(l1 < block_rows)) {
#line 144 "../lib/sudoku-board.vala"
					break;
#line 679 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 145 "../lib/sudoku-board.vala"
					l2 = 0;
#line 685 "sudoku-board.c"
					{
						gboolean _tmp30_ = FALSE;
#line 145 "../lib/sudoku-board.vala"
						_tmp30_ = TRUE;
#line 145 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 145 "../lib/sudoku-board.vala"
							if (!_tmp30_) {
#line 694 "sudoku-board.c"
								gint _tmp31_;
#line 145 "../lib/sudoku-board.vala"
								_tmp31_ = l2;
#line 145 "../lib/sudoku-board.vala"
								l2 = _tmp31_ + 1;
#line 700 "sudoku-board.c"
							}
#line 145 "../lib/sudoku-board.vala"
							_tmp30_ = FALSE;
#line 145 "../lib/sudoku-board.vala"
							if (!(l2 < block_cols)) {
#line 145 "../lib/sudoku-board.vala"
								break;
#line 708 "sudoku-board.c"
							}
							{
								gint l3 = 0;
#line 146 "../lib/sudoku-board.vala"
								l3 = 0;
#line 714 "sudoku-board.c"
								{
									gboolean _tmp32_ = FALSE;
#line 146 "../lib/sudoku-board.vala"
									_tmp32_ = TRUE;
#line 146 "../lib/sudoku-board.vala"
									while (TRUE) {
#line 721 "sudoku-board.c"
										gint _tmp34_;
										gint _tmp35_;
										gint* _tmp36_;
										gint _tmp36__length1;
										gint _tmp36__length2;
										gint _tmp36__length3;
#line 146 "../lib/sudoku-board.vala"
										if (!_tmp32_) {
#line 730 "sudoku-board.c"
											gint _tmp33_;
#line 146 "../lib/sudoku-board.vala"
											_tmp33_ = l3;
#line 146 "../lib/sudoku-board.vala"
											l3 = _tmp33_ + 1;
#line 736 "sudoku-board.c"
										}
#line 146 "../lib/sudoku-board.vala"
										_tmp32_ = FALSE;
#line 146 "../lib/sudoku-board.vala"
										_tmp34_ = sudoku_board_get_max_val (self);
#line 146 "../lib/sudoku-board.vala"
										_tmp35_ = _tmp34_;
#line 146 "../lib/sudoku-board.vala"
										if (!(l3 < _tmp35_)) {
#line 146 "../lib/sudoku-board.vala"
											break;
#line 748 "sudoku-board.c"
										}
#line 147 "../lib/sudoku-board.vala"
										_tmp36_ = self->priv->occurences_in_block;
#line 147 "../lib/sudoku-board.vala"
										_tmp36__length1 = self->priv->occurences_in_block_length1;
#line 147 "../lib/sudoku-board.vala"
										_tmp36__length2 = self->priv->occurences_in_block_length2;
#line 147 "../lib/sudoku-board.vala"
										_tmp36__length3 = self->priv->occurences_in_block_length3;
#line 147 "../lib/sudoku-board.vala"
										_tmp36_[(((l1 * _tmp36__length2) + l2) * _tmp36__length3) + l3] = 0;
#line 760 "sudoku-board.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 149 "../lib/sudoku-board.vala"
	_tmp37_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 149 "../lib/sudoku-board.vala"
	_tmp38_ = _tmp37_;
#line 149 "../lib/sudoku-board.vala"
	sudoku_board_set_broken_coords (self, (GeeSet*) _tmp38_);
#line 149 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp38_);
#line 151 "../lib/sudoku-board.vala"
	_tmp39_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 151 "../lib/sudoku-board.vala"
	_tmp40_ = _tmp39_;
#line 151 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_col (self, (GeeList*) _tmp40_);
#line 151 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp40_);
#line 786 "sudoku-board.c"
	{
		gint col = 0;
#line 152 "../lib/sudoku-board.vala"
		col = 0;
#line 791 "sudoku-board.c"
		{
			gboolean _tmp41_ = FALSE;
#line 152 "../lib/sudoku-board.vala"
			_tmp41_ = TRUE;
#line 152 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 798 "sudoku-board.c"
				gint _tmp43_;
				GeeList* _tmp44_;
				GeeArrayList* _tmp45_;
				GeeArrayList* _tmp46_;
				GeeList* _tmp54_;
				GeeList* _tmp55_;
				gpointer _tmp56_;
				GeeList* _tmp57_;
				GeeList* _tmp58_;
				GeeList* _tmp59_;
				GeeList* _tmp60_;
#line 152 "../lib/sudoku-board.vala"
				if (!_tmp41_) {
#line 812 "sudoku-board.c"
					gint _tmp42_;
#line 152 "../lib/sudoku-board.vala"
					_tmp42_ = col;
#line 152 "../lib/sudoku-board.vala"
					col = _tmp42_ + 1;
#line 818 "sudoku-board.c"
				}
#line 152 "../lib/sudoku-board.vala"
				_tmp41_ = FALSE;
#line 152 "../lib/sudoku-board.vala"
				_tmp43_ = self->priv->_cols;
#line 152 "../lib/sudoku-board.vala"
				if (!(col < _tmp43_)) {
#line 152 "../lib/sudoku-board.vala"
					break;
#line 828 "sudoku-board.c"
				}
#line 154 "../lib/sudoku-board.vala"
				_tmp44_ = self->priv->_coords_for_col;
#line 154 "../lib/sudoku-board.vala"
				_tmp45_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 154 "../lib/sudoku-board.vala"
				_tmp46_ = _tmp45_;
#line 154 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp44_, (GeeList*) _tmp46_);
#line 154 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp46_);
#line 840 "sudoku-board.c"
				{
					gint row = 0;
#line 155 "../lib/sudoku-board.vala"
					row = 0;
#line 845 "sudoku-board.c"
					{
						gboolean _tmp47_ = FALSE;
#line 155 "../lib/sudoku-board.vala"
						_tmp47_ = TRUE;
#line 155 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 852 "sudoku-board.c"
							gint _tmp49_;
							GeeList* _tmp50_;
							gpointer _tmp51_;
							GeeList* _tmp52_;
							Coord _tmp53_ = {0};
#line 155 "../lib/sudoku-board.vala"
							if (!_tmp47_) {
#line 860 "sudoku-board.c"
								gint _tmp48_;
#line 155 "../lib/sudoku-board.vala"
								_tmp48_ = row;
#line 155 "../lib/sudoku-board.vala"
								row = _tmp48_ + 1;
#line 866 "sudoku-board.c"
							}
#line 155 "../lib/sudoku-board.vala"
							_tmp47_ = FALSE;
#line 155 "../lib/sudoku-board.vala"
							_tmp49_ = self->priv->_rows;
#line 155 "../lib/sudoku-board.vala"
							if (!(row < _tmp49_)) {
#line 155 "../lib/sudoku-board.vala"
								break;
#line 876 "sudoku-board.c"
							}
#line 156 "../lib/sudoku-board.vala"
							_tmp50_ = self->priv->_coords_for_col;
#line 156 "../lib/sudoku-board.vala"
							_tmp51_ = gee_list_get (_tmp50_, col);
#line 156 "../lib/sudoku-board.vala"
							_tmp52_ = (GeeList*) _tmp51_;
#line 156 "../lib/sudoku-board.vala"
							coord_init (&_tmp53_, row, col);
#line 156 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp52_, &_tmp53_);
#line 156 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp52_);
#line 890 "sudoku-board.c"
						}
					}
				}
#line 158 "../lib/sudoku-board.vala"
				_tmp54_ = self->priv->_coords_for_col;
#line 158 "../lib/sudoku-board.vala"
				_tmp55_ = self->priv->_coords_for_col;
#line 158 "../lib/sudoku-board.vala"
				_tmp56_ = gee_list_get (_tmp55_, col);
#line 158 "../lib/sudoku-board.vala"
				_tmp57_ = (GeeList*) _tmp56_;
#line 158 "../lib/sudoku-board.vala"
				_tmp58_ = gee_list_get_read_only_view (_tmp57_);
#line 158 "../lib/sudoku-board.vala"
				_tmp59_ = _tmp58_;
#line 158 "../lib/sudoku-board.vala"
				_tmp60_ = _tmp59_;
#line 158 "../lib/sudoku-board.vala"
				gee_list_set (_tmp54_, col, _tmp60_);
#line 158 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp60_);
#line 158 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp57_);
#line 914 "sudoku-board.c"
			}
		}
	}
#line 160 "../lib/sudoku-board.vala"
	_tmp61_ = self->priv->_coords_for_col;
#line 160 "../lib/sudoku-board.vala"
	_tmp62_ = gee_list_get_read_only_view (_tmp61_);
#line 160 "../lib/sudoku-board.vala"
	_tmp63_ = _tmp62_;
#line 160 "../lib/sudoku-board.vala"
	_tmp64_ = _tmp63_;
#line 160 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_col (self, _tmp64_);
#line 160 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp64_);
#line 162 "../lib/sudoku-board.vala"
	_tmp65_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 162 "../lib/sudoku-board.vala"
	_tmp66_ = _tmp65_;
#line 162 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_row (self, (GeeList*) _tmp66_);
#line 162 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp66_);
#line 938 "sudoku-board.c"
	{
		gint row = 0;
#line 163 "../lib/sudoku-board.vala"
		row = 0;
#line 943 "sudoku-board.c"
		{
			gboolean _tmp67_ = FALSE;
#line 163 "../lib/sudoku-board.vala"
			_tmp67_ = TRUE;
#line 163 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 950 "sudoku-board.c"
				gint _tmp69_;
				GeeList* _tmp70_;
				GeeArrayList* _tmp71_;
				GeeArrayList* _tmp72_;
				GeeList* _tmp80_;
				GeeList* _tmp81_;
				gpointer _tmp82_;
				GeeList* _tmp83_;
				GeeList* _tmp84_;
				GeeList* _tmp85_;
				GeeList* _tmp86_;
#line 163 "../lib/sudoku-board.vala"
				if (!_tmp67_) {
#line 964 "sudoku-board.c"
					gint _tmp68_;
#line 163 "../lib/sudoku-board.vala"
					_tmp68_ = row;
#line 163 "../lib/sudoku-board.vala"
					row = _tmp68_ + 1;
#line 970 "sudoku-board.c"
				}
#line 163 "../lib/sudoku-board.vala"
				_tmp67_ = FALSE;
#line 163 "../lib/sudoku-board.vala"
				_tmp69_ = self->priv->_rows;
#line 163 "../lib/sudoku-board.vala"
				if (!(row < _tmp69_)) {
#line 163 "../lib/sudoku-board.vala"
					break;
#line 980 "sudoku-board.c"
				}
#line 165 "../lib/sudoku-board.vala"
				_tmp70_ = self->priv->_coords_for_row;
#line 165 "../lib/sudoku-board.vala"
				_tmp71_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 165 "../lib/sudoku-board.vala"
				_tmp72_ = _tmp71_;
#line 165 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp70_, (GeeList*) _tmp72_);
#line 165 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp72_);
#line 992 "sudoku-board.c"
				{
					gint col = 0;
#line 166 "../lib/sudoku-board.vala"
					col = 0;
#line 997 "sudoku-board.c"
					{
						gboolean _tmp73_ = FALSE;
#line 166 "../lib/sudoku-board.vala"
						_tmp73_ = TRUE;
#line 166 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1004 "sudoku-board.c"
							gint _tmp75_;
							GeeList* _tmp76_;
							gpointer _tmp77_;
							GeeList* _tmp78_;
							Coord _tmp79_ = {0};
#line 166 "../lib/sudoku-board.vala"
							if (!_tmp73_) {
#line 1012 "sudoku-board.c"
								gint _tmp74_;
#line 166 "../lib/sudoku-board.vala"
								_tmp74_ = col;
#line 166 "../lib/sudoku-board.vala"
								col = _tmp74_ + 1;
#line 1018 "sudoku-board.c"
							}
#line 166 "../lib/sudoku-board.vala"
							_tmp73_ = FALSE;
#line 166 "../lib/sudoku-board.vala"
							_tmp75_ = self->priv->_cols;
#line 166 "../lib/sudoku-board.vala"
							if (!(col < _tmp75_)) {
#line 166 "../lib/sudoku-board.vala"
								break;
#line 1028 "sudoku-board.c"
							}
#line 167 "../lib/sudoku-board.vala"
							_tmp76_ = self->priv->_coords_for_row;
#line 167 "../lib/sudoku-board.vala"
							_tmp77_ = gee_list_get (_tmp76_, row);
#line 167 "../lib/sudoku-board.vala"
							_tmp78_ = (GeeList*) _tmp77_;
#line 167 "../lib/sudoku-board.vala"
							coord_init (&_tmp79_, row, col);
#line 167 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp78_, &_tmp79_);
#line 167 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp78_);
#line 1042 "sudoku-board.c"
						}
					}
				}
#line 169 "../lib/sudoku-board.vala"
				_tmp80_ = self->priv->_coords_for_row;
#line 169 "../lib/sudoku-board.vala"
				_tmp81_ = self->priv->_coords_for_row;
#line 169 "../lib/sudoku-board.vala"
				_tmp82_ = gee_list_get (_tmp81_, row);
#line 169 "../lib/sudoku-board.vala"
				_tmp83_ = (GeeList*) _tmp82_;
#line 169 "../lib/sudoku-board.vala"
				_tmp84_ = gee_list_get_read_only_view (_tmp83_);
#line 169 "../lib/sudoku-board.vala"
				_tmp85_ = _tmp84_;
#line 169 "../lib/sudoku-board.vala"
				_tmp86_ = _tmp85_;
#line 169 "../lib/sudoku-board.vala"
				gee_list_set (_tmp80_, row, _tmp86_);
#line 169 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp86_);
#line 169 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp83_);
#line 1066 "sudoku-board.c"
			}
		}
	}
#line 171 "../lib/sudoku-board.vala"
	_tmp87_ = self->priv->_coords_for_row;
#line 171 "../lib/sudoku-board.vala"
	_tmp88_ = gee_list_get_read_only_view (_tmp87_);
#line 171 "../lib/sudoku-board.vala"
	_tmp89_ = _tmp88_;
#line 171 "../lib/sudoku-board.vala"
	_tmp90_ = _tmp89_;
#line 171 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_row (self, _tmp90_);
#line 171 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp90_);
#line 173 "../lib/sudoku-board.vala"
	_tmp91_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 173 "../lib/sudoku-board.vala"
	_tmp92_ = _tmp91_;
#line 173 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_block (self, (GeeMap*) _tmp92_);
#line 173 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp92_);
#line 1090 "sudoku-board.c"
	{
		gint col = 0;
#line 174 "../lib/sudoku-board.vala"
		col = 0;
#line 1095 "sudoku-board.c"
		{
			gboolean _tmp93_ = FALSE;
#line 174 "../lib/sudoku-board.vala"
			_tmp93_ = TRUE;
#line 174 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 174 "../lib/sudoku-board.vala"
				if (!_tmp93_) {
#line 1104 "sudoku-board.c"
					gint _tmp94_;
#line 174 "../lib/sudoku-board.vala"
					_tmp94_ = col;
#line 174 "../lib/sudoku-board.vala"
					col = _tmp94_ + 1;
#line 1110 "sudoku-board.c"
				}
#line 174 "../lib/sudoku-board.vala"
				_tmp93_ = FALSE;
#line 174 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 174 "../lib/sudoku-board.vala"
					break;
#line 1118 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 175 "../lib/sudoku-board.vala"
					row = 0;
#line 1124 "sudoku-board.c"
					{
						gboolean _tmp95_ = FALSE;
#line 175 "../lib/sudoku-board.vala"
						_tmp95_ = TRUE;
#line 175 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1131 "sudoku-board.c"
							GeeMap* _tmp97_;
							Coord _tmp98_ = {0};
							GeeArrayList* _tmp99_;
							GeeArrayList* _tmp100_;
#line 175 "../lib/sudoku-board.vala"
							if (!_tmp95_) {
#line 1138 "sudoku-board.c"
								gint _tmp96_;
#line 175 "../lib/sudoku-board.vala"
								_tmp96_ = row;
#line 175 "../lib/sudoku-board.vala"
								row = _tmp96_ + 1;
#line 1144 "sudoku-board.c"
							}
#line 175 "../lib/sudoku-board.vala"
							_tmp95_ = FALSE;
#line 175 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 175 "../lib/sudoku-board.vala"
								break;
#line 1152 "sudoku-board.c"
							}
#line 176 "../lib/sudoku-board.vala"
							_tmp97_ = self->priv->_coords_for_block;
#line 176 "../lib/sudoku-board.vala"
							coord_init (&_tmp98_, row, col);
#line 176 "../lib/sudoku-board.vala"
							_tmp99_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 176 "../lib/sudoku-board.vala"
							_tmp100_ = _tmp99_;
#line 176 "../lib/sudoku-board.vala"
							gee_map_set (_tmp97_, &_tmp98_, (GeeList*) _tmp100_);
#line 176 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp100_);
#line 1166 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 178 "../lib/sudoku-board.vala"
		col = 0;
#line 1177 "sudoku-board.c"
		{
			gboolean _tmp101_ = FALSE;
#line 178 "../lib/sudoku-board.vala"
			_tmp101_ = TRUE;
#line 178 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1184 "sudoku-board.c"
				gint _tmp103_;
#line 178 "../lib/sudoku-board.vala"
				if (!_tmp101_) {
#line 1188 "sudoku-board.c"
					gint _tmp102_;
#line 178 "../lib/sudoku-board.vala"
					_tmp102_ = col;
#line 178 "../lib/sudoku-board.vala"
					col = _tmp102_ + 1;
#line 1194 "sudoku-board.c"
				}
#line 178 "../lib/sudoku-board.vala"
				_tmp101_ = FALSE;
#line 178 "../lib/sudoku-board.vala"
				_tmp103_ = self->priv->_cols;
#line 178 "../lib/sudoku-board.vala"
				if (!(col < _tmp103_)) {
#line 178 "../lib/sudoku-board.vala"
					break;
#line 1204 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 179 "../lib/sudoku-board.vala"
					row = 0;
#line 1210 "sudoku-board.c"
					{
						gboolean _tmp104_ = FALSE;
#line 179 "../lib/sudoku-board.vala"
						_tmp104_ = TRUE;
#line 179 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1217 "sudoku-board.c"
							gint _tmp106_;
							GeeMap* _tmp107_;
							Coord _tmp108_ = {0};
							gpointer _tmp109_;
							GeeList* _tmp110_;
							Coord _tmp111_ = {0};
#line 179 "../lib/sudoku-board.vala"
							if (!_tmp104_) {
#line 1226 "sudoku-board.c"
								gint _tmp105_;
#line 179 "../lib/sudoku-board.vala"
								_tmp105_ = row;
#line 179 "../lib/sudoku-board.vala"
								row = _tmp105_ + 1;
#line 1232 "sudoku-board.c"
							}
#line 179 "../lib/sudoku-board.vala"
							_tmp104_ = FALSE;
#line 179 "../lib/sudoku-board.vala"
							_tmp106_ = self->priv->_rows;
#line 179 "../lib/sudoku-board.vala"
							if (!(row < _tmp106_)) {
#line 179 "../lib/sudoku-board.vala"
								break;
#line 1242 "sudoku-board.c"
							}
#line 180 "../lib/sudoku-board.vala"
							_tmp107_ = self->priv->_coords_for_block;
#line 180 "../lib/sudoku-board.vala"
							coord_init (&_tmp108_, row / block_rows, col / block_cols);
#line 180 "../lib/sudoku-board.vala"
							_tmp109_ = gee_map_get (_tmp107_, &_tmp108_);
#line 180 "../lib/sudoku-board.vala"
							_tmp110_ = (GeeList*) _tmp109_;
#line 180 "../lib/sudoku-board.vala"
							coord_init (&_tmp111_, row, col);
#line 180 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp110_, &_tmp111_);
#line 180 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp110_);
#line 1258 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 182 "../lib/sudoku-board.vala"
		col = 0;
#line 1269 "sudoku-board.c"
		{
			gboolean _tmp112_ = FALSE;
#line 182 "../lib/sudoku-board.vala"
			_tmp112_ = TRUE;
#line 182 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 182 "../lib/sudoku-board.vala"
				if (!_tmp112_) {
#line 1278 "sudoku-board.c"
					gint _tmp113_;
#line 182 "../lib/sudoku-board.vala"
					_tmp113_ = col;
#line 182 "../lib/sudoku-board.vala"
					col = _tmp113_ + 1;
#line 1284 "sudoku-board.c"
				}
#line 182 "../lib/sudoku-board.vala"
				_tmp112_ = FALSE;
#line 182 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 182 "../lib/sudoku-board.vala"
					break;
#line 1292 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 183 "../lib/sudoku-board.vala"
					row = 0;
#line 1298 "sudoku-board.c"
					{
						gboolean _tmp114_ = FALSE;
#line 183 "../lib/sudoku-board.vala"
						_tmp114_ = TRUE;
#line 183 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1305 "sudoku-board.c"
							GeeMap* _tmp116_;
							Coord _tmp117_ = {0};
							GeeMap* _tmp118_;
							Coord _tmp119_ = {0};
							gpointer _tmp120_;
							GeeList* _tmp121_;
							GeeList* _tmp122_;
							GeeList* _tmp123_;
							GeeList* _tmp124_;
#line 183 "../lib/sudoku-board.vala"
							if (!_tmp114_) {
#line 1317 "sudoku-board.c"
								gint _tmp115_;
#line 183 "../lib/sudoku-board.vala"
								_tmp115_ = row;
#line 183 "../lib/sudoku-board.vala"
								row = _tmp115_ + 1;
#line 1323 "sudoku-board.c"
							}
#line 183 "../lib/sudoku-board.vala"
							_tmp114_ = FALSE;
#line 183 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 183 "../lib/sudoku-board.vala"
								break;
#line 1331 "sudoku-board.c"
							}
#line 184 "../lib/sudoku-board.vala"
							_tmp116_ = self->priv->_coords_for_block;
#line 184 "../lib/sudoku-board.vala"
							coord_init (&_tmp117_, row, col);
#line 184 "../lib/sudoku-board.vala"
							_tmp118_ = self->priv->_coords_for_block;
#line 184 "../lib/sudoku-board.vala"
							coord_init (&_tmp119_, row, col);
#line 184 "../lib/sudoku-board.vala"
							_tmp120_ = gee_map_get (_tmp118_, &_tmp119_);
#line 184 "../lib/sudoku-board.vala"
							_tmp121_ = (GeeList*) _tmp120_;
#line 184 "../lib/sudoku-board.vala"
							_tmp122_ = gee_list_get_read_only_view (_tmp121_);
#line 184 "../lib/sudoku-board.vala"
							_tmp123_ = _tmp122_;
#line 184 "../lib/sudoku-board.vala"
							_tmp124_ = _tmp123_;
#line 184 "../lib/sudoku-board.vala"
							gee_map_set (_tmp116_, &_tmp117_, _tmp124_);
#line 184 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp124_);
#line 184 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp121_);
#line 1357 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 186 "../lib/sudoku-board.vala"
	_tmp125_ = self->priv->_coords_for_block;
#line 186 "../lib/sudoku-board.vala"
	_tmp126_ = gee_map_get_read_only_view (_tmp125_);
#line 186 "../lib/sudoku-board.vala"
	_tmp127_ = _tmp126_;
#line 186 "../lib/sudoku-board.vala"
	_tmp128_ = _tmp127_;
#line 186 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_block (self, _tmp128_);
#line 186 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp128_);
#line 122 "../lib/sudoku-board.vala"
	return self;
#line 1378 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_new (gint block_rows,
                  gint block_cols)
{
#line 122 "../lib/sudoku-board.vala"
	return sudoku_board_construct (TYPE_SUDOKU_BOARD, block_rows, block_cols);
#line 1387 "sudoku-board.c"
}

static gint*
_vala_array_dup1 (gint* self,
                  gssize length)
{
#line 192 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 192 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1398 "sudoku-board.c"
	}
#line 192 "../lib/sudoku-board.vala"
	return NULL;
#line 1402 "sudoku-board.c"
}

static gint*
_vala_array_dup2 (gint* self,
                  gssize length)
{
#line 193 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 193 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1413 "sudoku-board.c"
	}
#line 193 "../lib/sudoku-board.vala"
	return NULL;
#line 1417 "sudoku-board.c"
}

static gboolean*
_vala_array_dup3 (gboolean* self,
                  gssize length)
{
#line 194 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 194 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1428 "sudoku-board.c"
	}
#line 194 "../lib/sudoku-board.vala"
	return NULL;
#line 1432 "sudoku-board.c"
}

static gint*
_vala_array_dup4 (gint* self,
                  gssize length)
{
#line 195 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 195 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1443 "sudoku-board.c"
	}
#line 195 "../lib/sudoku-board.vala"
	return NULL;
#line 1447 "sudoku-board.c"
}

static gint*
_vala_array_dup5 (gint* self,
                  gssize length)
{
#line 196 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 196 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1458 "sudoku-board.c"
	}
#line 196 "../lib/sudoku-board.vala"
	return NULL;
#line 1462 "sudoku-board.c"
}

static gint*
_vala_array_dup6 (gint* self,
                  gssize length)
{
#line 197 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 197 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1473 "sudoku-board.c"
	}
#line 197 "../lib/sudoku-board.vala"
	return NULL;
#line 1477 "sudoku-board.c"
}

static gboolean*
_vala_array_dup7 (gboolean* self,
                  gssize length)
{
#line 202 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 202 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1488 "sudoku-board.c"
	}
#line 202 "../lib/sudoku-board.vala"
	return NULL;
#line 1492 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_clone (SudokuBoard* self)
{
	SudokuBoard* board = NULL;
	gint _tmp0_;
	gint _tmp1_;
	SudokuBoard* _tmp2_;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gint* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
	gint* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gint* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	gint _tmp13__length3;
	gint* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	gint _tmp14__length3;
	gint _tmp15_;
	gint _tmp16_;
	GeeSet* _tmp17_;
	GeeSet* _tmp18_;
	gboolean* _tmp19_;
	gint _tmp19__length1;
	gint _tmp19__length2;
	gint _tmp19__length3;
	gboolean* _tmp20_;
	gint _tmp20__length1;
	gint _tmp20__length2;
	gint _tmp20__length3;
	DifficultyCategory _tmp21_;
	SudokuBoard* result;
#line 189 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 191 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 191 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_new (_tmp0_, _tmp1_);
#line 191 "../lib/sudoku-board.vala"
	board = _tmp2_;
#line 192 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->cells;
#line 192 "../lib/sudoku-board.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 192 "../lib/sudoku-board.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 192 "../lib/sudoku-board.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1 * _tmp3__length2) : _tmp3_;
#line 192 "../lib/sudoku-board.vala"
	_tmp4__length1 = _tmp3__length1;
#line 192 "../lib/sudoku-board.vala"
	_tmp4__length2 = _tmp3__length2;
#line 192 "../lib/sudoku-board.vala"
	board->priv->cells = (g_free (board->priv->cells), NULL);
#line 192 "../lib/sudoku-board.vala"
	board->priv->cells = _tmp4_;
#line 192 "../lib/sudoku-board.vala"
	board->priv->cells_length1 = _tmp4__length1;
#line 192 "../lib/sudoku-board.vala"
	board->priv->cells_length2 = _tmp4__length2;
#line 193 "../lib/sudoku-board.vala"
	_tmp5_ = self->priv->solution;
#line 193 "../lib/sudoku-board.vala"
	_tmp5__length1 = self->priv->solution_length1;
#line 193 "../lib/sudoku-board.vala"
	_tmp5__length2 = self->priv->solution_length2;
#line 193 "../lib/sudoku-board.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup2 (_tmp5_, _tmp5__length1 * _tmp5__length2) : _tmp5_;
#line 193 "../lib/sudoku-board.vala"
	_tmp6__length1 = _tmp5__length1;
#line 193 "../lib/sudoku-board.vala"
	_tmp6__length2 = _tmp5__length2;
#line 193 "../lib/sudoku-board.vala"
	board->priv->solution = (g_free (board->priv->solution), NULL);
#line 193 "../lib/sudoku-board.vala"
	board->priv->solution = _tmp6_;
#line 193 "../lib/sudoku-board.vala"
	board->priv->solution_length1 = _tmp6__length1;
#line 193 "../lib/sudoku-board.vala"
	board->priv->solution_length2 = _tmp6__length2;
#line 194 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->is_fixed;
#line 194 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->priv->is_fixed_length1;
#line 194 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->priv->is_fixed_length2;
#line 194 "../lib/sudoku-board.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup3 (_tmp7_, _tmp7__length1 * _tmp7__length2) : _tmp7_;
#line 194 "../lib/sudoku-board.vala"
	_tmp8__length1 = _tmp7__length1;
#line 194 "../lib/sudoku-board.vala"
	_tmp8__length2 = _tmp7__length2;
#line 194 "../lib/sudoku-board.vala"
	board->priv->is_fixed = (g_free (board->priv->is_fixed), NULL);
#line 194 "../lib/sudoku-board.vala"
	board->priv->is_fixed = _tmp8_;
#line 194 "../lib/sudoku-board.vala"
	board->priv->is_fixed_length1 = _tmp8__length1;
#line 194 "../lib/sudoku-board.vala"
	board->priv->is_fixed_length2 = _tmp8__length2;
#line 195 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->occurences_in_row;
#line 195 "../lib/sudoku-board.vala"
	_tmp9__length1 = self->priv->occurences_in_row_length1;
#line 195 "../lib/sudoku-board.vala"
	_tmp9__length2 = self->priv->occurences_in_row_length2;
#line 195 "../lib/sudoku-board.vala"
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup4 (_tmp9_, _tmp9__length1 * _tmp9__length2) : _tmp9_;
#line 195 "../lib/sudoku-board.vala"
	_tmp10__length1 = _tmp9__length1;
#line 195 "../lib/sudoku-board.vala"
	_tmp10__length2 = _tmp9__length2;
#line 195 "../lib/sudoku-board.vala"
	board->priv->occurences_in_row = (g_free (board->priv->occurences_in_row), NULL);
#line 195 "../lib/sudoku-board.vala"
	board->priv->occurences_in_row = _tmp10_;
#line 195 "../lib/sudoku-board.vala"
	board->priv->occurences_in_row_length1 = _tmp10__length1;
#line 195 "../lib/sudoku-board.vala"
	board->priv->occurences_in_row_length2 = _tmp10__length2;
#line 196 "../lib/sudoku-board.vala"
	_tmp11_ = self->priv->occurences_in_col;
#line 196 "../lib/sudoku-board.vala"
	_tmp11__length1 = self->priv->occurences_in_col_length1;
#line 196 "../lib/sudoku-board.vala"
	_tmp11__length2 = self->priv->occurences_in_col_length2;
#line 196 "../lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup5 (_tmp11_, _tmp11__length1 * _tmp11__length2) : _tmp11_;
#line 196 "../lib/sudoku-board.vala"
	_tmp12__length1 = _tmp11__length1;
#line 196 "../lib/sudoku-board.vala"
	_tmp12__length2 = _tmp11__length2;
#line 196 "../lib/sudoku-board.vala"
	board->priv->occurences_in_col = (g_free (board->priv->occurences_in_col), NULL);
#line 196 "../lib/sudoku-board.vala"
	board->priv->occurences_in_col = _tmp12_;
#line 196 "../lib/sudoku-board.vala"
	board->priv->occurences_in_col_length1 = _tmp12__length1;
#line 196 "../lib/sudoku-board.vala"
	board->priv->occurences_in_col_length2 = _tmp12__length2;
#line 197 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->occurences_in_block;
#line 197 "../lib/sudoku-board.vala"
	_tmp13__length1 = self->priv->occurences_in_block_length1;
#line 197 "../lib/sudoku-board.vala"
	_tmp13__length2 = self->priv->occurences_in_block_length2;
#line 197 "../lib/sudoku-board.vala"
	_tmp13__length3 = self->priv->occurences_in_block_length3;
#line 197 "../lib/sudoku-board.vala"
	_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup6 (_tmp13_, (_tmp13__length1 * _tmp13__length2) * _tmp13__length3) : _tmp13_;
#line 197 "../lib/sudoku-board.vala"
	_tmp14__length1 = _tmp13__length1;
#line 197 "../lib/sudoku-board.vala"
	_tmp14__length2 = _tmp13__length2;
#line 197 "../lib/sudoku-board.vala"
	_tmp14__length3 = _tmp13__length3;
#line 197 "../lib/sudoku-board.vala"
	board->priv->occurences_in_block = (g_free (board->priv->occurences_in_block), NULL);
#line 197 "../lib/sudoku-board.vala"
	board->priv->occurences_in_block = _tmp14_;
#line 197 "../lib/sudoku-board.vala"
	board->priv->occurences_in_block_length1 = _tmp14__length1;
#line 197 "../lib/sudoku-board.vala"
	board->priv->occurences_in_block_length2 = _tmp14__length2;
#line 197 "../lib/sudoku-board.vala"
	board->priv->occurences_in_block_length3 = _tmp14__length3;
#line 198 "../lib/sudoku-board.vala"
	_tmp15_ = self->priv->_filled;
#line 198 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (board, _tmp15_);
#line 199 "../lib/sudoku-board.vala"
	_tmp16_ = self->priv->_fixed;
#line 199 "../lib/sudoku-board.vala"
	sudoku_board_set_fixed (board, _tmp16_);
#line 200 "../lib/sudoku-board.vala"
	board->priv->n_earmarks = self->priv->n_earmarks;
#line 201 "../lib/sudoku-board.vala"
	_tmp17_ = board->priv->_broken_coords;
#line 201 "../lib/sudoku-board.vala"
	_tmp18_ = self->priv->_broken_coords;
#line 201 "../lib/sudoku-board.vala"
	gee_collection_add_all ((GeeCollection*) _tmp17_, (GeeCollection*) _tmp18_);
#line 202 "../lib/sudoku-board.vala"
	_tmp19_ = self->priv->earmarks;
#line 202 "../lib/sudoku-board.vala"
	_tmp19__length1 = self->priv->earmarks_length1;
#line 202 "../lib/sudoku-board.vala"
	_tmp19__length2 = self->priv->earmarks_length2;
#line 202 "../lib/sudoku-board.vala"
	_tmp19__length3 = self->priv->earmarks_length3;
#line 202 "../lib/sudoku-board.vala"
	_tmp20_ = (_tmp19_ != NULL) ? _vala_array_dup7 (_tmp19_, (_tmp19__length1 * _tmp19__length2) * _tmp19__length3) : _tmp19_;
#line 202 "../lib/sudoku-board.vala"
	_tmp20__length1 = _tmp19__length1;
#line 202 "../lib/sudoku-board.vala"
	_tmp20__length2 = _tmp19__length2;
#line 202 "../lib/sudoku-board.vala"
	_tmp20__length3 = _tmp19__length3;
#line 202 "../lib/sudoku-board.vala"
	board->priv->earmarks = (g_free (board->priv->earmarks), NULL);
#line 202 "../lib/sudoku-board.vala"
	board->priv->earmarks = _tmp20_;
#line 202 "../lib/sudoku-board.vala"
	board->priv->earmarks_length1 = _tmp20__length1;
#line 202 "../lib/sudoku-board.vala"
	board->priv->earmarks_length2 = _tmp20__length2;
#line 202 "../lib/sudoku-board.vala"
	board->priv->earmarks_length3 = _tmp20__length3;
#line 203 "../lib/sudoku-board.vala"
	_tmp21_ = self->priv->_difficulty_category;
#line 203 "../lib/sudoku-board.vala"
	sudoku_board_set_difficulty_category (board, _tmp21_);
#line 205 "../lib/sudoku-board.vala"
	result = board;
#line 205 "../lib/sudoku-board.vala"
	return result;
#line 1740 "sudoku-board.c"
}

gboolean
sudoku_board_get_is_fixed (SudokuBoard* self,
                           gint row,
                           gint column)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean _tmp1_;
	gboolean result;
#line 208 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 210 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->is_fixed;
#line 210 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->is_fixed_length1;
#line 210 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->is_fixed_length2;
#line 210 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + column];
#line 210 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 210 "../lib/sudoku-board.vala"
	return result;
#line 1767 "sudoku-board.c"
}

void
sudoku_board_set_is_fixed (SudokuBoard* self,
                           gint row,
                           gint column,
                           gboolean _value)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 213 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 215 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->is_fixed;
#line 215 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->is_fixed_length1;
#line 215 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->is_fixed_length2;
#line 215 "../lib/sudoku-board.vala"
	_tmp0_[(row * _tmp0__length2) + column] = _value;
#line 1789 "sudoku-board.c"
}

void
sudoku_board_enable_earmark (SudokuBoard* self,
                             gint row,
                             gint column,
                             gint num)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp2__length3;
	gboolean _tmp3_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp4__length3;
	gint _tmp5_;
#line 218 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 218 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 218 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 218 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 218 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + column];
#line 218 "../lib/sudoku-board.vala"
	_vala_return_if_fail (_tmp1_ == 0, "cells[row, column] == 0");
#line 218 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->earmarks;
#line 218 "../lib/sudoku-board.vala"
	_tmp2__length1 = self->priv->earmarks_length1;
#line 218 "../lib/sudoku-board.vala"
	_tmp2__length2 = self->priv->earmarks_length2;
#line 218 "../lib/sudoku-board.vala"
	_tmp2__length3 = self->priv->earmarks_length3;
#line 218 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (num - 1)];
#line 218 "../lib/sudoku-board.vala"
	_vala_return_if_fail (!_tmp3_, "!earmarks[row, column, num-1]");
#line 222 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->earmarks;
#line 222 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->priv->earmarks_length1;
#line 222 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->priv->earmarks_length2;
#line 222 "../lib/sudoku-board.vala"
	_tmp4__length3 = self->priv->earmarks_length3;
#line 222 "../lib/sudoku-board.vala"
	_tmp4_[(((row * _tmp4__length2) + column) * _tmp4__length3) + (num - 1)] = TRUE;
#line 223 "../lib/sudoku-board.vala"
	_tmp5_ = self->priv->n_earmarks;
#line 223 "../lib/sudoku-board.vala"
	self->priv->n_earmarks = _tmp5_ + 1;
#line 224 "../lib/sudoku-board.vala"
	g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL], 0, row, column, num, TRUE);
#line 1852 "sudoku-board.c"
}

void
sudoku_board_disable_earmark (SudokuBoard* self,
                              gint row,
                              gint column,
                              gint num)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp2__length3;
	gboolean _tmp3_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp4__length3;
	gint _tmp5_;
#line 227 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 227 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 227 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 227 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 227 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + column];
#line 227 "../lib/sudoku-board.vala"
	_vala_return_if_fail (_tmp1_ == 0, "cells[row, column] == 0");
#line 227 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->earmarks;
#line 227 "../lib/sudoku-board.vala"
	_tmp2__length1 = self->priv->earmarks_length1;
#line 227 "../lib/sudoku-board.vala"
	_tmp2__length2 = self->priv->earmarks_length2;
#line 227 "../lib/sudoku-board.vala"
	_tmp2__length3 = self->priv->earmarks_length3;
#line 227 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (num - 1)];
#line 227 "../lib/sudoku-board.vala"
	_vala_return_if_fail (_tmp3_, "earmarks[row, column, num-1]");
#line 231 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->earmarks;
#line 231 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->priv->earmarks_length1;
#line 231 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->priv->earmarks_length2;
#line 231 "../lib/sudoku-board.vala"
	_tmp4__length3 = self->priv->earmarks_length3;
#line 231 "../lib/sudoku-board.vala"
	_tmp4_[(((row * _tmp4__length2) + column) * _tmp4__length3) + (num - 1)] = FALSE;
#line 232 "../lib/sudoku-board.vala"
	_tmp5_ = self->priv->n_earmarks;
#line 232 "../lib/sudoku-board.vala"
	self->priv->n_earmarks = _tmp5_ - 1;
#line 233 "../lib/sudoku-board.vala"
	g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL], 0, row, column, num, FALSE);
#line 1915 "sudoku-board.c"
}

void
sudoku_board_disable_all_earmarks (SudokuBoard* self,
                                   gint row,
                                   gint column)
{
#line 236 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 1925 "sudoku-board.c"
	{
		gint i = 0;
#line 238 "../lib/sudoku-board.vala"
		i = 1;
#line 1930 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 238 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 238 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1937 "sudoku-board.c"
				gint _tmp2_;
				gint _tmp3_;
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				gint _tmp4__length3;
				gboolean _tmp5_;
#line 238 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 1947 "sudoku-board.c"
					gint _tmp1_;
#line 238 "../lib/sudoku-board.vala"
					_tmp1_ = i;
#line 238 "../lib/sudoku-board.vala"
					i = _tmp1_ + 1;
#line 1953 "sudoku-board.c"
				}
#line 238 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 238 "../lib/sudoku-board.vala"
				_tmp2_ = sudoku_board_get_max_val (self);
#line 238 "../lib/sudoku-board.vala"
				_tmp3_ = _tmp2_;
#line 238 "../lib/sudoku-board.vala"
				if (!(i <= _tmp3_)) {
#line 238 "../lib/sudoku-board.vala"
					break;
#line 1965 "sudoku-board.c"
				}
#line 239 "../lib/sudoku-board.vala"
				_tmp4_ = self->priv->earmarks;
#line 239 "../lib/sudoku-board.vala"
				_tmp4__length1 = self->priv->earmarks_length1;
#line 239 "../lib/sudoku-board.vala"
				_tmp4__length2 = self->priv->earmarks_length2;
#line 239 "../lib/sudoku-board.vala"
				_tmp4__length3 = self->priv->earmarks_length3;
#line 239 "../lib/sudoku-board.vala"
				_tmp5_ = _tmp4_[(((row * _tmp4__length2) + column) * _tmp4__length3) + (i - 1)];
#line 239 "../lib/sudoku-board.vala"
				if (_tmp5_) {
#line 240 "../lib/sudoku-board.vala"
					sudoku_board_disable_earmark (self, row, column, i);
#line 1981 "sudoku-board.c"
				}
			}
		}
	}
}

gboolean
sudoku_board_is_earmark_enabled (SudokuBoard* self,
                                 gint row,
                                 gint column,
                                 gint num)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
	gboolean result;
#line 243 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 245 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 245 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 245 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 245 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 245 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (num - 1)];
#line 245 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 245 "../lib/sudoku-board.vala"
	return result;
#line 2016 "sudoku-board.c"
}

gboolean
sudoku_board_is_possible (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
	gboolean result;
#line 248 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->occurences_in_row;
#line 250 "../lib/sudoku-board.vala"
	_tmp2__length1 = self->priv->occurences_in_row_length1;
#line 250 "../lib/sudoku-board.vala"
	_tmp2__length2 = self->priv->occurences_in_row_length2;
#line 250 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + (val - 1)];
#line 250 "../lib/sudoku-board.vala"
	if (_tmp3_ == 0) {
#line 2044 "sudoku-board.c"
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
#line 251 "../lib/sudoku-board.vala"
		_tmp4_ = self->priv->occurences_in_col;
#line 251 "../lib/sudoku-board.vala"
		_tmp4__length1 = self->priv->occurences_in_col_length1;
#line 251 "../lib/sudoku-board.vala"
		_tmp4__length2 = self->priv->occurences_in_col_length2;
#line 251 "../lib/sudoku-board.vala"
		_tmp5_ = _tmp4_[(col * _tmp4__length2) + (val - 1)];
#line 251 "../lib/sudoku-board.vala"
		_tmp1_ = _tmp5_ == 0;
#line 2059 "sudoku-board.c"
	} else {
#line 250 "../lib/sudoku-board.vala"
		_tmp1_ = FALSE;
#line 2063 "sudoku-board.c"
	}
#line 250 "../lib/sudoku-board.vala"
	if (_tmp1_) {
#line 2067 "sudoku-board.c"
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint _tmp6__length3;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 252 "../lib/sudoku-board.vala"
		_tmp6_ = self->priv->occurences_in_block;
#line 252 "../lib/sudoku-board.vala"
		_tmp6__length1 = self->priv->occurences_in_block_length1;
#line 252 "../lib/sudoku-board.vala"
		_tmp6__length2 = self->priv->occurences_in_block_length2;
#line 252 "../lib/sudoku-board.vala"
		_tmp6__length3 = self->priv->occurences_in_block_length3;
#line 252 "../lib/sudoku-board.vala"
		_tmp7_ = self->priv->_block_cols;
#line 252 "../lib/sudoku-board.vala"
		_tmp8_ = self->priv->_block_rows;
#line 252 "../lib/sudoku-board.vala"
		_tmp9_ = _tmp6_[((((row / _tmp7_) * _tmp6__length2) + (col / _tmp8_)) * _tmp6__length3) + (val - 1)];
#line 252 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp9_ == 0;
#line 2091 "sudoku-board.c"
	} else {
#line 250 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 2095 "sudoku-board.c"
	}
#line 250 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 250 "../lib/sudoku-board.vala"
	return result;
#line 2101 "sudoku-board.c"
}

gint
sudoku_board_count_possibilities (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint result;
#line 255 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 257 "../lib/sudoku-board.vala"
	_tmp1_ = sudoku_board_get_possibilities (self, row, col, &_tmp0_);
#line 257 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 257 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp0_;
#line 257 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp0_;
#line 257 "../lib/sudoku-board.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 257 "../lib/sudoku-board.vala"
	result = _tmp3_;
#line 257 "../lib/sudoku-board.vala"
	return result;
#line 2131 "sudoku-board.c"
}

static gint*
_vala_array_dup8 (gint* self,
                  gssize length)
{
#line 276 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 276 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 2142 "sudoku-board.c"
	}
#line 276 "../lib/sudoku-board.vala"
	return NULL;
#line 2146 "sudoku-board.c"
}

gint*
sudoku_board_get_possibilities (SudokuBoard* self,
                                gint row,
                                gint col,
                                gint* result_length1)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* possibilities = NULL;
	gint* _tmp4_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gint count = 0;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint* _tmp13_;
	gint _tmp13__length1;
	gint* result;
#line 260 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 262 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 262 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 262 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 262 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 262 "../lib/sudoku-board.vala"
	if (_tmp1_ != 0) {
#line 2183 "sudoku-board.c"
		gint* _tmp2_;
		gint* _tmp3_;
		gint _tmp3__length1;
#line 263 "../lib/sudoku-board.vala"
		_tmp2_ = g_new0 (gint, 0);
#line 263 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 263 "../lib/sudoku-board.vala"
		_tmp3__length1 = 0;
#line 263 "../lib/sudoku-board.vala"
		if (result_length1) {
#line 263 "../lib/sudoku-board.vala"
			*result_length1 = _tmp3__length1;
#line 2197 "sudoku-board.c"
		}
#line 263 "../lib/sudoku-board.vala"
		result = _tmp3_;
#line 263 "../lib/sudoku-board.vala"
		return result;
#line 2203 "sudoku-board.c"
	}
#line 265 "../lib/sudoku-board.vala"
	_tmp4_ = g_new0 (gint, 9);
#line 265 "../lib/sudoku-board.vala"
	possibilities = _tmp4_;
#line 265 "../lib/sudoku-board.vala"
	possibilities_length1 = 9;
#line 265 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 266 "../lib/sudoku-board.vala"
	count = 0;
#line 2215 "sudoku-board.c"
	{
		gint l = 0;
#line 268 "../lib/sudoku-board.vala"
		l = 1;
#line 2220 "sudoku-board.c"
		{
			gboolean _tmp5_ = FALSE;
#line 268 "../lib/sudoku-board.vala"
			_tmp5_ = TRUE;
#line 268 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 2227 "sudoku-board.c"
				gint _tmp7_;
				gint _tmp8_;
#line 268 "../lib/sudoku-board.vala"
				if (!_tmp5_) {
#line 2232 "sudoku-board.c"
					gint _tmp6_;
#line 268 "../lib/sudoku-board.vala"
					_tmp6_ = l;
#line 268 "../lib/sudoku-board.vala"
					l = _tmp6_ + 1;
#line 2238 "sudoku-board.c"
				}
#line 268 "../lib/sudoku-board.vala"
				_tmp5_ = FALSE;
#line 268 "../lib/sudoku-board.vala"
				_tmp7_ = sudoku_board_get_max_val (self);
#line 268 "../lib/sudoku-board.vala"
				_tmp8_ = _tmp7_;
#line 268 "../lib/sudoku-board.vala"
				if (!(l <= _tmp8_)) {
#line 268 "../lib/sudoku-board.vala"
					break;
#line 2250 "sudoku-board.c"
				}
#line 270 "../lib/sudoku-board.vala"
				if (sudoku_board_is_possible (self, row, col, l)) {
#line 2254 "sudoku-board.c"
					gint* _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_;
#line 272 "../lib/sudoku-board.vala"
					_tmp9_ = possibilities;
#line 272 "../lib/sudoku-board.vala"
					_tmp9__length1 = possibilities_length1;
#line 272 "../lib/sudoku-board.vala"
					_tmp9_[count] = l;
#line 273 "../lib/sudoku-board.vala"
					_tmp10_ = count;
#line 273 "../lib/sudoku-board.vala"
					count = _tmp10_ + 1;
#line 2268 "sudoku-board.c"
				}
			}
		}
	}
#line 276 "../lib/sudoku-board.vala"
	_tmp11_ = possibilities;
#line 276 "../lib/sudoku-board.vala"
	_tmp11__length1 = possibilities_length1;
#line 276 "../lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup8 (_tmp11_ + 0, count - 0) : _tmp11_;
#line 276 "../lib/sudoku-board.vala"
	_tmp12__length1 = count - 0;
#line 276 "../lib/sudoku-board.vala"
	_tmp13_ = _tmp12_;
#line 276 "../lib/sudoku-board.vala"
	_tmp13__length1 = _tmp12__length1;
#line 276 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 276 "../lib/sudoku-board.vala"
		*result_length1 = _tmp13__length1;
#line 2289 "sudoku-board.c"
	}
#line 276 "../lib/sudoku-board.vala"
	result = _tmp13_;
#line 276 "../lib/sudoku-board.vala"
	possibilities = (g_free (possibilities), NULL);
#line 276 "../lib/sudoku-board.vala"
	return result;
#line 2297 "sudoku-board.c"
}

gboolean*
sudoku_board_get_possibilities_as_bool_array (SudokuBoard* self,
                                              gint row,
                                              gint col,
                                              gint* result_length1)
{
	gboolean* possibilities = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result;
#line 279 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 281 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 281 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 281 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 281 "../lib/sudoku-board.vala"
	possibilities = _tmp2_;
#line 281 "../lib/sudoku-board.vala"
	possibilities_length1 = _tmp1_;
#line 281 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 2329 "sudoku-board.c"
	{
		gint l = 0;
#line 283 "../lib/sudoku-board.vala"
		l = 1;
#line 2334 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 283 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 283 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 2341 "sudoku-board.c"
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
#line 283 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 2348 "sudoku-board.c"
					gint _tmp4_;
#line 283 "../lib/sudoku-board.vala"
					_tmp4_ = l;
#line 283 "../lib/sudoku-board.vala"
					l = _tmp4_ + 1;
#line 2354 "sudoku-board.c"
				}
#line 283 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 283 "../lib/sudoku-board.vala"
				_tmp5_ = sudoku_board_get_max_val (self);
#line 283 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_;
#line 283 "../lib/sudoku-board.vala"
				if (!(l <= _tmp6_)) {
#line 283 "../lib/sudoku-board.vala"
					break;
#line 2366 "sudoku-board.c"
				}
#line 284 "../lib/sudoku-board.vala"
				_tmp7_ = possibilities;
#line 284 "../lib/sudoku-board.vala"
				_tmp7__length1 = possibilities_length1;
#line 284 "../lib/sudoku-board.vala"
				_tmp7_[l - 1] = sudoku_board_is_possible (self, row, col, l);
#line 2374 "sudoku-board.c"
			}
		}
	}
#line 286 "../lib/sudoku-board.vala"
	_tmp8_ = possibilities;
#line 286 "../lib/sudoku-board.vala"
	_tmp8__length1 = possibilities_length1;
#line 286 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 286 "../lib/sudoku-board.vala"
		*result_length1 = _tmp8__length1;
#line 2386 "sudoku-board.c"
	}
#line 286 "../lib/sudoku-board.vala"
	result = _tmp8_;
#line 286 "../lib/sudoku-board.vala"
	return result;
#line 2392 "sudoku-board.c"
}

void
sudoku_board_get_block_for (SudokuBoard* self,
                            gint row,
                            gint col,
                            Coord* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Coord _tmp2_ = {0};
#line 289 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 291 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 291 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 291 "../lib/sudoku-board.vala"
	coord_init (&_tmp2_, row / _tmp0_, col / _tmp1_);
#line 291 "../lib/sudoku-board.vala"
	*result = _tmp2_;
#line 291 "../lib/sudoku-board.vala"
	return;
#line 2416 "sudoku-board.c"
}

void
sudoku_board_insert (SudokuBoard* self,
                     gint row,
                     gint col,
                     gint val,
                     gboolean is_fixed)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
	gint old_val = 0;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 294 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 294 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 294 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 294 "../lib/sudoku-board.vala"
	_vala_return_if_fail ((val > 0) && (val <= _tmp1_), "val > 0 && val <= max_val");
#line 294 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->is_fixed;
#line 294 "../lib/sudoku-board.vala"
	_tmp2__length1 = self->priv->is_fixed_length1;
#line 294 "../lib/sudoku-board.vala"
	_tmp2__length2 = self->priv->is_fixed_length2;
#line 294 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 294 "../lib/sudoku-board.vala"
	_vala_return_if_fail (!_tmp3_, "!this.is_fixed[row, col]");
#line 298 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->cells;
#line 298 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 298 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 298 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 298 "../lib/sudoku-board.vala"
	old_val = _tmp5_;
#line 299 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->cells;
#line 299 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 299 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 299 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = val;
#line 301 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->is_fixed;
#line 301 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->priv->is_fixed_length1;
#line 301 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->priv->is_fixed_length2;
#line 301 "../lib/sudoku-board.vala"
	_tmp7_[(row * _tmp7__length2) + col] = is_fixed;
#line 302 "../lib/sudoku-board.vala"
	if (is_fixed) {
#line 2491 "sudoku-board.c"
		gint _tmp8_;
#line 303 "../lib/sudoku-board.vala"
		_tmp8_ = self->priv->_fixed;
#line 303 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp8_ + 1);
#line 2497 "sudoku-board.c"
	}
#line 305 "../lib/sudoku-board.vala"
	if (old_val != 0) {
#line 306 "../lib/sudoku-board.vala"
		sudoku_board_update_old_breakages (self, row, col, old_val);
#line 2503 "sudoku-board.c"
	} else {
		gint _tmp9_;
#line 308 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_filled;
#line 308 "../lib/sudoku-board.vala"
		sudoku_board_set_filled (self, _tmp9_ + 1);
#line 2510 "sudoku-board.c"
	}
#line 310 "../lib/sudoku-board.vala"
	sudoku_board_mark_breakages (self, row, col, val);
#line 311 "../lib/sudoku-board.vala"
	sudoku_board_add_to_occurences (self, row, col, val, 1);
#line 313 "../lib/sudoku-board.vala"
	_tmp10_ = sudoku_board_get_complete (self);
#line 313 "../lib/sudoku-board.vala"
	_tmp11_ = _tmp10_;
#line 313 "../lib/sudoku-board.vala"
	if (_tmp11_) {
#line 314 "../lib/sudoku-board.vala"
		g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL], 0);
#line 2524 "sudoku-board.c"
	}
#line 315 "../lib/sudoku-board.vala"
	g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_CELL_CHANGED_SIGNAL], 0, row, col, old_val, val);
#line 2528 "sudoku-board.c"
}

void
sudoku_board_remove (SudokuBoard* self,
                     gint row,
                     gint col)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
	gint old_val = 0;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gint _tmp7_;
#line 318 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 318 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 318 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 318 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 318 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 318 "../lib/sudoku-board.vala"
	_vala_return_if_fail (_tmp1_ > 0, "cells[row, col] > 0");
#line 318 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->is_fixed;
#line 318 "../lib/sudoku-board.vala"
	_tmp2__length1 = self->priv->is_fixed_length1;
#line 318 "../lib/sudoku-board.vala"
	_tmp2__length2 = self->priv->is_fixed_length2;
#line 318 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 318 "../lib/sudoku-board.vala"
	_vala_return_if_fail (!_tmp3_, "!this.is_fixed[row, col]");
#line 322 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->cells;
#line 322 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 322 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 322 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 322 "../lib/sudoku-board.vala"
	old_val = _tmp5_;
#line 323 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->cells;
#line 323 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 323 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 323 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = 0;
#line 324 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->_filled;
#line 324 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp7_ - 1);
#line 325 "../lib/sudoku-board.vala"
	sudoku_board_update_old_breakages (self, row, col, old_val);
#line 326 "../lib/sudoku-board.vala"
	g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_CELL_CHANGED_SIGNAL], 0, row, col, old_val, 0);
#line 2601 "sudoku-board.c"
}

gint
sudoku_board_get (SudokuBoard* self,
                  gint row,
                  gint col)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint result;
#line 329 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 331 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 331 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 331 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 331 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 331 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 331 "../lib/sudoku-board.vala"
	return result;
#line 2628 "sudoku-board.c"
}

void
sudoku_board_set (SudokuBoard* self,
                  gint row,
                  gint col,
                  gint val)
{
#line 334 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 336 "../lib/sudoku-board.vala"
	if (val == 0) {
#line 337 "../lib/sudoku-board.vala"
		sudoku_board_remove (self, row, col);
#line 2643 "sudoku-board.c"
	} else {
		gboolean _tmp0_ = FALSE;
#line 338 "../lib/sudoku-board.vala"
		if (val > 0) {
#line 2648 "sudoku-board.c"
			gint _tmp1_;
			gint _tmp2_;
#line 338 "../lib/sudoku-board.vala"
			_tmp1_ = sudoku_board_get_max_val (self);
#line 338 "../lib/sudoku-board.vala"
			_tmp2_ = _tmp1_;
#line 338 "../lib/sudoku-board.vala"
			_tmp0_ = val <= _tmp2_;
#line 2657 "sudoku-board.c"
		} else {
#line 338 "../lib/sudoku-board.vala"
			_tmp0_ = FALSE;
#line 2661 "sudoku-board.c"
		}
#line 338 "../lib/sudoku-board.vala"
		if (_tmp0_) {
#line 339 "../lib/sudoku-board.vala"
			sudoku_board_insert (self, row, col, val, FALSE);
#line 2667 "sudoku-board.c"
		} else {
#line 341 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 2671 "sudoku-board.c"
		}
	}
}

static void
sudoku_board_update_old_breakages (SudokuBoard* self,
                                   gint row,
                                   gint col,
                                   gint val)
{
	GeeSet* _tmp0_;
	Coord _tmp1_ = {0};
#line 344 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 346 "../lib/sudoku-board.vala"
	sudoku_board_add_to_occurences (self, row, col, val, -1);
#line 348 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_broken_coords;
#line 348 "../lib/sudoku-board.vala"
	coord_init (&_tmp1_, row, col);
#line 348 "../lib/sudoku-board.vala"
	if (gee_collection_contains ((GeeCollection*) _tmp0_, &_tmp1_)) {
#line 2694 "sudoku-board.c"
		GeeSet* _tmp2_;
		Coord _tmp3_ = {0};
		GeeList* _tmp4_;
		gpointer _tmp5_;
		GeeList* _tmp6_;
		GeeList* _tmp7_;
		gpointer _tmp8_;
		GeeList* _tmp9_;
		GeeMap* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		Coord _tmp13_ = {0};
		gpointer _tmp14_;
		GeeList* _tmp15_;
#line 350 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->_broken_coords;
#line 350 "../lib/sudoku-board.vala"
		coord_init (&_tmp3_, row, col);
#line 350 "../lib/sudoku-board.vala"
		gee_collection_remove ((GeeCollection*) _tmp2_, &_tmp3_);
#line 352 "../lib/sudoku-board.vala"
		_tmp4_ = self->priv->_coords_for_row;
#line 352 "../lib/sudoku-board.vala"
		_tmp5_ = gee_list_get (_tmp4_, row);
#line 352 "../lib/sudoku-board.vala"
		_tmp6_ = (GeeList*) _tmp5_;
#line 352 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp6_, val);
#line 352 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp6_);
#line 353 "../lib/sudoku-board.vala"
		_tmp7_ = self->priv->_coords_for_col;
#line 353 "../lib/sudoku-board.vala"
		_tmp8_ = gee_list_get (_tmp7_, col);
#line 353 "../lib/sudoku-board.vala"
		_tmp9_ = (GeeList*) _tmp8_;
#line 353 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp9_, val);
#line 353 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp9_);
#line 354 "../lib/sudoku-board.vala"
		_tmp10_ = self->priv->_coords_for_block;
#line 354 "../lib/sudoku-board.vala"
		_tmp11_ = self->priv->_block_rows;
#line 354 "../lib/sudoku-board.vala"
		_tmp12_ = self->priv->_block_cols;
#line 354 "../lib/sudoku-board.vala"
		coord_init (&_tmp13_, row / _tmp11_, col / _tmp12_);
#line 354 "../lib/sudoku-board.vala"
		_tmp14_ = gee_map_get (_tmp10_, &_tmp13_);
#line 354 "../lib/sudoku-board.vala"
		_tmp15_ = (GeeList*) _tmp14_;
#line 354 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp15_, val);
#line 354 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp15_);
#line 2751 "sudoku-board.c"
	}
}

static void
sudoku_board_add_to_occurences (SudokuBoard* self,
                                gint row,
                                gint col,
                                gint val,
                                gint add)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp2__length3;
	gint _tmp3_;
	gint _tmp4_;
#line 358 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 360 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->occurences_in_row;
#line 360 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->occurences_in_row_length1;
#line 360 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->occurences_in_row_length2;
#line 360 "../lib/sudoku-board.vala"
	_tmp0_[(row * _tmp0__length2) + (val - 1)] += add;
#line 361 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->occurences_in_col;
#line 361 "../lib/sudoku-board.vala"
	_tmp1__length1 = self->priv->occurences_in_col_length1;
#line 361 "../lib/sudoku-board.vala"
	_tmp1__length2 = self->priv->occurences_in_col_length2;
#line 361 "../lib/sudoku-board.vala"
	_tmp1_[(col * _tmp1__length2) + (val - 1)] += add;
#line 362 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->occurences_in_block;
#line 362 "../lib/sudoku-board.vala"
	_tmp2__length1 = self->priv->occurences_in_block_length1;
#line 362 "../lib/sudoku-board.vala"
	_tmp2__length2 = self->priv->occurences_in_block_length2;
#line 362 "../lib/sudoku-board.vala"
	_tmp2__length3 = self->priv->occurences_in_block_length3;
#line 362 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_block_cols;
#line 362 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->_block_rows;
#line 362 "../lib/sudoku-board.vala"
	_tmp2_[((((row / _tmp3_) * _tmp2__length2) + (col / _tmp4_)) * _tmp2__length3) + (val - 1)] += add;
#line 2806 "sudoku-board.c"
}

static void
sudoku_board_mark_breakages (SudokuBoard* self,
                             gint row,
                             gint col,
                             gint val)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gint _tmp6_;
	gint* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gint _tmp10__length3;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
#line 365 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 367 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->occurences_in_row;
#line 367 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->occurences_in_row_length1;
#line 367 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->occurences_in_row_length2;
#line 367 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + (val - 1)];
#line 367 "../lib/sudoku-board.vala"
	if (_tmp1_ > 0) {
#line 2842 "sudoku-board.c"
		GeeList* _tmp2_;
		gpointer _tmp3_;
		GeeList* _tmp4_;
#line 368 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->_coords_for_row;
#line 368 "../lib/sudoku-board.vala"
		_tmp3_ = gee_list_get (_tmp2_, row);
#line 368 "../lib/sudoku-board.vala"
		_tmp4_ = (GeeList*) _tmp3_;
#line 368 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp4_, val);
#line 368 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp4_);
#line 2856 "sudoku-board.c"
	}
#line 370 "../lib/sudoku-board.vala"
	_tmp5_ = self->priv->occurences_in_col;
#line 370 "../lib/sudoku-board.vala"
	_tmp5__length1 = self->priv->occurences_in_col_length1;
#line 370 "../lib/sudoku-board.vala"
	_tmp5__length2 = self->priv->occurences_in_col_length2;
#line 370 "../lib/sudoku-board.vala"
	_tmp6_ = _tmp5_[(col * _tmp5__length2) + (val - 1)];
#line 370 "../lib/sudoku-board.vala"
	if (_tmp6_ > 0) {
#line 2868 "sudoku-board.c"
		GeeList* _tmp7_;
		gpointer _tmp8_;
		GeeList* _tmp9_;
#line 371 "../lib/sudoku-board.vala"
		_tmp7_ = self->priv->_coords_for_col;
#line 371 "../lib/sudoku-board.vala"
		_tmp8_ = gee_list_get (_tmp7_, col);
#line 371 "../lib/sudoku-board.vala"
		_tmp9_ = (GeeList*) _tmp8_;
#line 371 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp9_, val);
#line 371 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp9_);
#line 2882 "sudoku-board.c"
	}
#line 373 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->occurences_in_block;
#line 373 "../lib/sudoku-board.vala"
	_tmp10__length1 = self->priv->occurences_in_block_length1;
#line 373 "../lib/sudoku-board.vala"
	_tmp10__length2 = self->priv->occurences_in_block_length2;
#line 373 "../lib/sudoku-board.vala"
	_tmp10__length3 = self->priv->occurences_in_block_length3;
#line 373 "../lib/sudoku-board.vala"
	_tmp11_ = self->priv->_block_rows;
#line 373 "../lib/sudoku-board.vala"
	_tmp12_ = self->priv->_block_cols;
#line 373 "../lib/sudoku-board.vala"
	_tmp13_ = _tmp10_[((((row / _tmp11_) * _tmp10__length2) + (col / _tmp12_)) * _tmp10__length3) + (val - 1)];
#line 373 "../lib/sudoku-board.vala"
	if (_tmp13_ > 0) {
#line 2900 "sudoku-board.c"
		GeeMap* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		Coord _tmp17_ = {0};
		gpointer _tmp18_;
		GeeList* _tmp19_;
#line 374 "../lib/sudoku-board.vala"
		_tmp14_ = self->priv->_coords_for_block;
#line 374 "../lib/sudoku-board.vala"
		_tmp15_ = self->priv->_block_rows;
#line 374 "../lib/sudoku-board.vala"
		_tmp16_ = self->priv->_block_cols;
#line 374 "../lib/sudoku-board.vala"
		coord_init (&_tmp17_, row / _tmp15_, col / _tmp16_);
#line 374 "../lib/sudoku-board.vala"
		_tmp18_ = gee_map_get (_tmp14_, &_tmp17_);
#line 374 "../lib/sudoku-board.vala"
		_tmp19_ = (GeeList*) _tmp18_;
#line 374 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp19_, val);
#line 374 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp19_);
#line 2923 "sudoku-board.c"
	}
}

void
sudoku_board_set_solution (SudokuBoard* self,
                           gint row,
                           gint col,
                           gint val)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
#line 377 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 377 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->solution;
#line 377 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->solution_length1;
#line 377 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->solution_length2;
#line 377 "../lib/sudoku-board.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "solution != null");
#line 380 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->solution;
#line 380 "../lib/sudoku-board.vala"
	_tmp1__length1 = self->priv->solution_length1;
#line 380 "../lib/sudoku-board.vala"
	_tmp1__length2 = self->priv->solution_length2;
#line 380 "../lib/sudoku-board.vala"
	_tmp1_[(row * _tmp1__length2) + col] = val;
#line 2957 "sudoku-board.c"
}

gint
sudoku_board_get_solution (SudokuBoard* self,
                           gint row,
                           gint col)
{
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint result;
#line 383 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 385 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->solution;
#line 385 "../lib/sudoku-board.vala"
	_tmp1__length1 = self->priv->solution_length1;
#line 385 "../lib/sudoku-board.vala"
	_tmp1__length2 = self->priv->solution_length2;
#line 385 "../lib/sudoku-board.vala"
	if (_tmp1_ == NULL) {
#line 385 "../lib/sudoku-board.vala"
		_tmp0_ = 0;
#line 2982 "sudoku-board.c"
	} else {
		gint* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gint _tmp3_;
#line 385 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->solution;
#line 385 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->solution_length1;
#line 385 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->solution_length2;
#line 385 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 385 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp3_;
#line 2998 "sudoku-board.c"
	}
#line 385 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 385 "../lib/sudoku-board.vala"
	return result;
#line 3004 "sudoku-board.c"
}

static gint*
sudoku_board_fixed_cells_only (SudokuBoard* self,
                               gint* result_length1,
                               gint* result_length2)
{
	gint* _result_ = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _result__length1;
	gint _result__length2;
	gint* _tmp15_;
	gint _tmp15__length1;
	gint _tmp15__length2;
	gint* result;
#line 388 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 390 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 390 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 390 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 390 "../lib/sudoku-board.vala"
	_result_ = _tmp2_;
#line 390 "../lib/sudoku-board.vala"
	_result__length1 = _tmp0_;
#line 390 "../lib/sudoku-board.vala"
	_result__length2 = _tmp1_;
#line 3036 "sudoku-board.c"
	{
		gint row = 0;
#line 392 "../lib/sudoku-board.vala"
		row = 0;
#line 3041 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 392 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 392 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3048 "sudoku-board.c"
				gint _tmp5_;
#line 392 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 3052 "sudoku-board.c"
					gint _tmp4_;
#line 392 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 392 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 3058 "sudoku-board.c"
				}
#line 392 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 392 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 392 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 392 "../lib/sudoku-board.vala"
					break;
#line 3068 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 394 "../lib/sudoku-board.vala"
					col = 0;
#line 3074 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 394 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 394 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3081 "sudoku-board.c"
							gint _tmp8_;
							gboolean* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gboolean _tmp10_;
#line 394 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 3089 "sudoku-board.c"
								gint _tmp7_;
#line 394 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 394 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 3095 "sudoku-board.c"
							}
#line 394 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 394 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 394 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 394 "../lib/sudoku-board.vala"
								break;
#line 3105 "sudoku-board.c"
							}
#line 396 "../lib/sudoku-board.vala"
							_tmp9_ = self->priv->is_fixed;
#line 396 "../lib/sudoku-board.vala"
							_tmp9__length1 = self->priv->is_fixed_length1;
#line 396 "../lib/sudoku-board.vala"
							_tmp9__length2 = self->priv->is_fixed_length2;
#line 396 "../lib/sudoku-board.vala"
							_tmp10_ = _tmp9_[(row * _tmp9__length2) + col];
#line 396 "../lib/sudoku-board.vala"
							if (_tmp10_) {
#line 3117 "sudoku-board.c"
								gint* _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
								gint* _tmp12_;
								gint _tmp12__length1;
								gint _tmp12__length2;
								gint _tmp13_;
#line 397 "../lib/sudoku-board.vala"
								_tmp11_ = _result_;
#line 397 "../lib/sudoku-board.vala"
								_tmp11__length1 = _result__length1;
#line 397 "../lib/sudoku-board.vala"
								_tmp11__length2 = _result__length2;
#line 397 "../lib/sudoku-board.vala"
								_tmp12_ = self->priv->cells;
#line 397 "../lib/sudoku-board.vala"
								_tmp12__length1 = self->priv->cells_length1;
#line 397 "../lib/sudoku-board.vala"
								_tmp12__length2 = self->priv->cells_length2;
#line 397 "../lib/sudoku-board.vala"
								_tmp13_ = _tmp12_[(row * _tmp12__length2) + col];
#line 397 "../lib/sudoku-board.vala"
								_tmp11_[(row * _tmp11__length2) + col] = _tmp13_;
#line 3141 "sudoku-board.c"
							} else {
								gint* _tmp14_;
								gint _tmp14__length1;
								gint _tmp14__length2;
#line 399 "../lib/sudoku-board.vala"
								_tmp14_ = _result_;
#line 399 "../lib/sudoku-board.vala"
								_tmp14__length1 = _result__length1;
#line 399 "../lib/sudoku-board.vala"
								_tmp14__length2 = _result__length2;
#line 399 "../lib/sudoku-board.vala"
								_tmp14_[(row * _tmp14__length2) + col] = 0;
#line 3154 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 403 "../lib/sudoku-board.vala"
	_tmp15_ = _result_;
#line 403 "../lib/sudoku-board.vala"
	_tmp15__length1 = _result__length1;
#line 403 "../lib/sudoku-board.vala"
	_tmp15__length2 = _result__length2;
#line 403 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 403 "../lib/sudoku-board.vala"
		*result_length1 = _tmp15__length1;
#line 3172 "sudoku-board.c"
	}
#line 403 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 403 "../lib/sudoku-board.vala"
		*result_length2 = _tmp15__length2;
#line 3178 "sudoku-board.c"
	}
#line 403 "../lib/sudoku-board.vala"
	result = _tmp15_;
#line 403 "../lib/sudoku-board.vala"
	return result;
#line 3184 "sudoku-board.c"
}

void
sudoku_board_solve (SudokuBoard* self)
{
	gint* fixed_cells = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint* _tmp2_;
	gint fixed_cells_length1;
	gint fixed_cells_length2;
	gint* solution_1d = NULL;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint _tmp4_ = 0;
	gint* _tmp5_;
	gint solution_1d_length1;
	gint _solution_1d_size_;
	gint* _tmp6_;
	gint _tmp6__length1;
#line 406 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 408 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_fixed_cells_only (self, &_tmp0_, &_tmp1_);
#line 408 "../lib/sudoku-board.vala"
	fixed_cells = _tmp2_;
#line 408 "../lib/sudoku-board.vala"
	fixed_cells_length1 = _tmp0_;
#line 408 "../lib/sudoku-board.vala"
	fixed_cells_length2 = _tmp1_;
#line 409 "../lib/sudoku-board.vala"
	_tmp3_ = fixed_cells;
#line 409 "../lib/sudoku-board.vala"
	_tmp3__length1 = fixed_cells_length1;
#line 409 "../lib/sudoku-board.vala"
	_tmp3__length2 = fixed_cells_length2;
#line 409 "../lib/sudoku-board.vala"
	_tmp5_ = sudoku_board_convert_2d_to_1d (self, _tmp3_, (gint) _tmp3__length1, (gint) _tmp3__length2, &_tmp4_);
#line 409 "../lib/sudoku-board.vala"
	solution_1d = _tmp5_;
#line 409 "../lib/sudoku-board.vala"
	solution_1d_length1 = _tmp4_;
#line 409 "../lib/sudoku-board.vala"
	_solution_1d_size_ = solution_1d_length1;
#line 411 "../lib/sudoku-board.vala"
	_tmp6_ = solution_1d;
#line 411 "../lib/sudoku-board.vala"
	_tmp6__length1 = solution_1d_length1;
#line 411 "../lib/sudoku-board.vala"
	if (qqwing_solve_puzzle (_tmp6_)) {
#line 3236 "sudoku-board.c"
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint* _tmp10_;
#line 412 "../lib/sudoku-board.vala"
		_tmp7_ = solution_1d;
#line 412 "../lib/sudoku-board.vala"
		_tmp7__length1 = solution_1d_length1;
#line 412 "../lib/sudoku-board.vala"
		_tmp10_ = sudoku_board_convert_1d_to_2d (self, _tmp7_, (gint) _tmp7__length1, &_tmp8_, &_tmp9_);
#line 412 "../lib/sudoku-board.vala"
		self->priv->solution = (g_free (self->priv->solution), NULL);
#line 412 "../lib/sudoku-board.vala"
		self->priv->solution = _tmp10_;
#line 412 "../lib/sudoku-board.vala"
		self->priv->solution_length1 = _tmp8_;
#line 412 "../lib/sudoku-board.vala"
		self->priv->solution_length2 = _tmp9_;
#line 3256 "sudoku-board.c"
	} else {
#line 414 "../lib/sudoku-board.vala"
		self->priv->solution = (g_free (self->priv->solution), NULL);
#line 414 "../lib/sudoku-board.vala"
		self->priv->solution = NULL;
#line 414 "../lib/sudoku-board.vala"
		self->priv->solution_length1 = 0;
#line 414 "../lib/sudoku-board.vala"
		self->priv->solution_length2 = 0;
#line 3266 "sudoku-board.c"
	}
#line 406 "../lib/sudoku-board.vala"
	solution_1d = (g_free (solution_1d), NULL);
#line 406 "../lib/sudoku-board.vala"
	fixed_cells = (g_free (fixed_cells), NULL);
#line 3272 "sudoku-board.c"
}

gboolean
sudoku_board_solved (SudokuBoard* self)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean result;
#line 417 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 419 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->solution;
#line 419 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->solution_length1;
#line 419 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->solution_length2;
#line 419 "../lib/sudoku-board.vala"
	result = _tmp0_ != NULL;
#line 419 "../lib/sudoku-board.vala"
	return result;
#line 3294 "sudoku-board.c"
}

gint
sudoku_board_count_solutions_limited (SudokuBoard* self)
{
	gint* cells_1d = NULL;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_ = 0;
	gint* _tmp2_;
	gint cells_1d_length1;
	gint _cells_1d_size_;
	gint result;
#line 422 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 424 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 424 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 424 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 424 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_convert_2d_to_1d (self, _tmp0_, (gint) _tmp0__length1, (gint) _tmp0__length2, &_tmp1_);
#line 424 "../lib/sudoku-board.vala"
	cells_1d = _tmp2_;
#line 424 "../lib/sudoku-board.vala"
	cells_1d_length1 = _tmp1_;
#line 424 "../lib/sudoku-board.vala"
	_cells_1d_size_ = cells_1d_length1;
#line 426 "../lib/sudoku-board.vala"
	result = qqwing_count_solutions_limited (cells_1d);
#line 426 "../lib/sudoku-board.vala"
	cells_1d = (g_free (cells_1d), NULL);
#line 426 "../lib/sudoku-board.vala"
	return result;
#line 3331 "sudoku-board.c"
}

GeeSet*
sudoku_board_get_occurences (SudokuBoard* self,
                             GeeList* coords,
                             gint val)
{
	GeeSet* occurences = NULL;
	GeeHashSet* _tmp0_;
	GeeSet* result;
#line 429 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 429 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coords != NULL, NULL);
#line 431 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 431 "../lib/sudoku-board.vala"
	occurences = (GeeSet*) _tmp0_;
#line 3350 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		gint _coord_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _coord_index = 0;
#line 432 "../lib/sudoku-board.vala"
		_coord_list = coords;
#line 432 "../lib/sudoku-board.vala"
		_tmp1_ = _coord_list;
#line 432 "../lib/sudoku-board.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 432 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 432 "../lib/sudoku-board.vala"
		_coord_size = _tmp3_;
#line 432 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 432 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3372 "sudoku-board.c"
			gint _tmp4_;
			gint _tmp5_;
			Coord coord = {0};
			GeeList* _tmp6_;
			gpointer _tmp7_;
			Coord* _tmp8_;
			Coord _tmp9_;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint _tmp10__length2;
			Coord _tmp11_;
			Coord _tmp12_;
			gint _tmp13_;
#line 432 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 432 "../lib/sudoku-board.vala"
			_tmp4_ = _coord_index;
#line 432 "../lib/sudoku-board.vala"
			_tmp5_ = _coord_size;
#line 432 "../lib/sudoku-board.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 432 "../lib/sudoku-board.vala"
				break;
#line 3396 "sudoku-board.c"
			}
#line 432 "../lib/sudoku-board.vala"
			_tmp6_ = _coord_list;
#line 432 "../lib/sudoku-board.vala"
			_tmp7_ = gee_list_get (_tmp6_, _coord_index);
#line 432 "../lib/sudoku-board.vala"
			_tmp8_ = (Coord*) _tmp7_;
#line 432 "../lib/sudoku-board.vala"
			_tmp9_ = *_tmp8_;
#line 432 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp8_);
#line 432 "../lib/sudoku-board.vala"
			coord = _tmp9_;
#line 433 "../lib/sudoku-board.vala"
			_tmp10_ = self->priv->cells;
#line 433 "../lib/sudoku-board.vala"
			_tmp10__length1 = self->priv->cells_length1;
#line 433 "../lib/sudoku-board.vala"
			_tmp10__length2 = self->priv->cells_length2;
#line 433 "../lib/sudoku-board.vala"
			_tmp11_ = coord;
#line 433 "../lib/sudoku-board.vala"
			_tmp12_ = coord;
#line 433 "../lib/sudoku-board.vala"
			_tmp13_ = _tmp10_[(_tmp11_.row * _tmp10__length2) + _tmp12_.col];
#line 433 "../lib/sudoku-board.vala"
			if (_tmp13_ == val) {
#line 3424 "sudoku-board.c"
				GeeSet* _tmp14_;
				Coord _tmp15_;
#line 434 "../lib/sudoku-board.vala"
				_tmp14_ = occurences;
#line 434 "../lib/sudoku-board.vala"
				_tmp15_ = coord;
#line 434 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp14_, &_tmp15_);
#line 3433 "sudoku-board.c"
			}
		}
	}
#line 436 "../lib/sudoku-board.vala"
	result = occurences;
#line 436 "../lib/sudoku-board.vala"
	return result;
#line 3441 "sudoku-board.c"
}

gboolean
sudoku_board_row_contains (SudokuBoard* self,
                           gint row,
                           gint val)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gboolean result;
#line 439 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 441 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->occurences_in_row;
#line 441 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->occurences_in_row_length1;
#line 441 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->occurences_in_row_length2;
#line 441 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + (val - 1)];
#line 441 "../lib/sudoku-board.vala"
	result = _tmp1_ > 0;
#line 441 "../lib/sudoku-board.vala"
	return result;
#line 3468 "sudoku-board.c"
}

gboolean
sudoku_board_col_contains (SudokuBoard* self,
                           gint col,
                           gint val)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gboolean result;
#line 444 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 446 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->occurences_in_col;
#line 446 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->occurences_in_col_length1;
#line 446 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->occurences_in_col_length2;
#line 446 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(col * _tmp0__length2) + (val - 1)];
#line 446 "../lib/sudoku-board.vala"
	result = _tmp1_ > 0;
#line 446 "../lib/sudoku-board.vala"
	return result;
#line 3495 "sudoku-board.c"
}

gboolean
sudoku_board_block_contains (SudokuBoard* self,
                             gint row_block,
                             gint col_block,
                             gint val)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gint _tmp1_;
	gboolean result;
#line 449 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 451 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->occurences_in_block;
#line 451 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->occurences_in_block_length1;
#line 451 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->occurences_in_block_length2;
#line 451 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->occurences_in_block_length3;
#line 451 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row_block * _tmp0__length2) + col_block) * _tmp0__length3) + (val - 1)];
#line 451 "../lib/sudoku-board.vala"
	result = _tmp1_ > 0;
#line 451 "../lib/sudoku-board.vala"
	return result;
#line 3526 "sudoku-board.c"
}

static void
sudoku_board_remove_breakages_for (SudokuBoard* self,
                                   GeeList* coords,
                                   gint val)
{
#line 454 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 454 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 3538 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		gint _coord_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _coord_index = 0;
#line 456 "../lib/sudoku-board.vala"
		_coord_list = coords;
#line 456 "../lib/sudoku-board.vala"
		_tmp0_ = _coord_list;
#line 456 "../lib/sudoku-board.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 456 "../lib/sudoku-board.vala"
		_tmp2_ = _tmp1_;
#line 456 "../lib/sudoku-board.vala"
		_coord_size = _tmp2_;
#line 456 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 456 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3560 "sudoku-board.c"
			gint _tmp3_;
			gint _tmp4_;
			Coord coord = {0};
			GeeList* _tmp5_;
			gpointer _tmp6_;
			Coord* _tmp7_;
			Coord _tmp8_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			gint* _tmp13_;
			gint _tmp13__length1;
			gint _tmp13__length2;
			Coord _tmp14_;
			Coord _tmp15_;
			gint _tmp16_;
#line 456 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 456 "../lib/sudoku-board.vala"
			_tmp3_ = _coord_index;
#line 456 "../lib/sudoku-board.vala"
			_tmp4_ = _coord_size;
#line 456 "../lib/sudoku-board.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 456 "../lib/sudoku-board.vala"
				break;
#line 3588 "sudoku-board.c"
			}
#line 456 "../lib/sudoku-board.vala"
			_tmp5_ = _coord_list;
#line 456 "../lib/sudoku-board.vala"
			_tmp6_ = gee_list_get (_tmp5_, _coord_index);
#line 456 "../lib/sudoku-board.vala"
			_tmp7_ = (Coord*) _tmp6_;
#line 456 "../lib/sudoku-board.vala"
			_tmp8_ = *_tmp7_;
#line 456 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp7_);
#line 456 "../lib/sudoku-board.vala"
			coord = _tmp8_;
#line 457 "../lib/sudoku-board.vala"
			_tmp13_ = self->priv->cells;
#line 457 "../lib/sudoku-board.vala"
			_tmp13__length1 = self->priv->cells_length1;
#line 457 "../lib/sudoku-board.vala"
			_tmp13__length2 = self->priv->cells_length2;
#line 457 "../lib/sudoku-board.vala"
			_tmp14_ = coord;
#line 457 "../lib/sudoku-board.vala"
			_tmp15_ = coord;
#line 457 "../lib/sudoku-board.vala"
			_tmp16_ = _tmp13_[(_tmp14_.row * _tmp13__length2) + _tmp15_.col];
#line 457 "../lib/sudoku-board.vala"
			if (_tmp16_ == val) {
#line 3616 "sudoku-board.c"
				GeeSet* _tmp17_;
				Coord _tmp18_;
#line 458 "../lib/sudoku-board.vala"
				_tmp17_ = self->priv->_broken_coords;
#line 458 "../lib/sudoku-board.vala"
				_tmp18_ = coord;
#line 458 "../lib/sudoku-board.vala"
				_tmp12_ = gee_collection_contains ((GeeCollection*) _tmp17_, &_tmp18_);
#line 3625 "sudoku-board.c"
			} else {
#line 457 "../lib/sudoku-board.vala"
				_tmp12_ = FALSE;
#line 3629 "sudoku-board.c"
			}
#line 457 "../lib/sudoku-board.vala"
			if (_tmp12_) {
#line 3633 "sudoku-board.c"
				gint* _tmp19_;
				gint _tmp19__length1;
				gint _tmp19__length2;
				Coord _tmp20_;
				gint _tmp21_;
#line 459 "../lib/sudoku-board.vala"
				_tmp19_ = self->priv->occurences_in_row;
#line 459 "../lib/sudoku-board.vala"
				_tmp19__length1 = self->priv->occurences_in_row_length1;
#line 459 "../lib/sudoku-board.vala"
				_tmp19__length2 = self->priv->occurences_in_row_length2;
#line 459 "../lib/sudoku-board.vala"
				_tmp20_ = coord;
#line 459 "../lib/sudoku-board.vala"
				_tmp21_ = _tmp19_[(_tmp20_.row * _tmp19__length2) + (val - 1)];
#line 459 "../lib/sudoku-board.vala"
				_tmp11_ = _tmp21_ <= 1;
#line 3651 "sudoku-board.c"
			} else {
#line 457 "../lib/sudoku-board.vala"
				_tmp11_ = FALSE;
#line 3655 "sudoku-board.c"
			}
#line 457 "../lib/sudoku-board.vala"
			if (_tmp11_) {
#line 3659 "sudoku-board.c"
				gint* _tmp22_;
				gint _tmp22__length1;
				gint _tmp22__length2;
				Coord _tmp23_;
				gint _tmp24_;
#line 460 "../lib/sudoku-board.vala"
				_tmp22_ = self->priv->occurences_in_col;
#line 460 "../lib/sudoku-board.vala"
				_tmp22__length1 = self->priv->occurences_in_col_length1;
#line 460 "../lib/sudoku-board.vala"
				_tmp22__length2 = self->priv->occurences_in_col_length2;
#line 460 "../lib/sudoku-board.vala"
				_tmp23_ = coord;
#line 460 "../lib/sudoku-board.vala"
				_tmp24_ = _tmp22_[(_tmp23_.col * _tmp22__length2) + (val - 1)];
#line 460 "../lib/sudoku-board.vala"
				_tmp10_ = _tmp24_ <= 1;
#line 3677 "sudoku-board.c"
			} else {
#line 457 "../lib/sudoku-board.vala"
				_tmp10_ = FALSE;
#line 3681 "sudoku-board.c"
			}
#line 457 "../lib/sudoku-board.vala"
			if (_tmp10_) {
#line 3685 "sudoku-board.c"
				gint* _tmp25_;
				gint _tmp25__length1;
				gint _tmp25__length2;
				gint _tmp25__length3;
				Coord _tmp26_;
				gint _tmp27_;
				Coord _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
#line 461 "../lib/sudoku-board.vala"
				_tmp25_ = self->priv->occurences_in_block;
#line 461 "../lib/sudoku-board.vala"
				_tmp25__length1 = self->priv->occurences_in_block_length1;
#line 461 "../lib/sudoku-board.vala"
				_tmp25__length2 = self->priv->occurences_in_block_length2;
#line 461 "../lib/sudoku-board.vala"
				_tmp25__length3 = self->priv->occurences_in_block_length3;
#line 461 "../lib/sudoku-board.vala"
				_tmp26_ = coord;
#line 461 "../lib/sudoku-board.vala"
				_tmp27_ = self->priv->_block_cols;
#line 461 "../lib/sudoku-board.vala"
				_tmp28_ = coord;
#line 461 "../lib/sudoku-board.vala"
				_tmp29_ = self->priv->_block_rows;
#line 461 "../lib/sudoku-board.vala"
				_tmp30_ = _tmp25_[((((_tmp26_.row / _tmp27_) * _tmp25__length2) + (_tmp28_.col / _tmp29_)) * _tmp25__length3) + (val - 1)];
#line 461 "../lib/sudoku-board.vala"
				_tmp9_ = _tmp30_ <= 1;
#line 3715 "sudoku-board.c"
			} else {
#line 457 "../lib/sudoku-board.vala"
				_tmp9_ = FALSE;
#line 3719 "sudoku-board.c"
			}
#line 457 "../lib/sudoku-board.vala"
			if (_tmp9_) {
#line 3723 "sudoku-board.c"
				GeeSet* _tmp31_;
				Coord _tmp32_;
#line 463 "../lib/sudoku-board.vala"
				_tmp31_ = self->priv->_broken_coords;
#line 463 "../lib/sudoku-board.vala"
				_tmp32_ = coord;
#line 463 "../lib/sudoku-board.vala"
				gee_collection_remove ((GeeCollection*) _tmp31_, &_tmp32_);
#line 3732 "sudoku-board.c"
			}
		}
	}
}

static void
sudoku_board_mark_breakages_for (SudokuBoard* self,
                                 GeeList* coords,
                                 gint val)
{
	GeeSet* occurences = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 468 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 468 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 470 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_occurences (self, coords, val);
#line 470 "../lib/sudoku-board.vala"
	occurences = _tmp0_;
#line 471 "../lib/sudoku-board.vala"
	_tmp1_ = occurences;
#line 471 "../lib/sudoku-board.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 471 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 471 "../lib/sudoku-board.vala"
	if (_tmp3_ != 1) {
#line 3764 "sudoku-board.c"
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 472 "../lib/sudoku-board.vala"
		_tmp4_ = self->priv->_broken_coords;
#line 472 "../lib/sudoku-board.vala"
		_tmp5_ = occurences;
#line 472 "../lib/sudoku-board.vala"
		gee_collection_add_all ((GeeCollection*) _tmp4_, (GeeCollection*) _tmp5_);
#line 3773 "sudoku-board.c"
	}
#line 468 "../lib/sudoku-board.vala"
	_g_object_unref0 (occurences);
#line 3777 "sudoku-board.c"
}

void
sudoku_board_to_initial_state (SudokuBoard* self)
{
#line 475 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3785 "sudoku-board.c"
	{
		gint l1 = 0;
#line 477 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3790 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 477 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 477 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3797 "sudoku-board.c"
				gint _tmp2_;
#line 477 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3801 "sudoku-board.c"
					gint _tmp1_;
#line 477 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 477 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3807 "sudoku-board.c"
				}
#line 477 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 477 "../lib/sudoku-board.vala"
				_tmp2_ = self->priv->_rows;
#line 477 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp2_)) {
#line 477 "../lib/sudoku-board.vala"
					break;
#line 3817 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 478 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3823 "sudoku-board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 478 "../lib/sudoku-board.vala"
						_tmp3_ = TRUE;
#line 478 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3830 "sudoku-board.c"
							gint _tmp5_;
							gboolean* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gboolean _tmp7_;
#line 478 "../lib/sudoku-board.vala"
							if (!_tmp3_) {
#line 3838 "sudoku-board.c"
								gint _tmp4_;
#line 478 "../lib/sudoku-board.vala"
								_tmp4_ = l2;
#line 478 "../lib/sudoku-board.vala"
								l2 = _tmp4_ + 1;
#line 3844 "sudoku-board.c"
							}
#line 478 "../lib/sudoku-board.vala"
							_tmp3_ = FALSE;
#line 478 "../lib/sudoku-board.vala"
							_tmp5_ = self->priv->_cols;
#line 478 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp5_)) {
#line 478 "../lib/sudoku-board.vala"
								break;
#line 3854 "sudoku-board.c"
							}
#line 479 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->is_fixed;
#line 479 "../lib/sudoku-board.vala"
							_tmp6__length1 = self->priv->is_fixed_length1;
#line 479 "../lib/sudoku-board.vala"
							_tmp6__length2 = self->priv->is_fixed_length2;
#line 479 "../lib/sudoku-board.vala"
							_tmp7_ = _tmp6_[(l1 * _tmp6__length2) + l2];
#line 479 "../lib/sudoku-board.vala"
							if (!_tmp7_) {
#line 480 "../lib/sudoku-board.vala"
								sudoku_board_remove (self, l1, l2);
#line 3868 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
}

void
sudoku_board_print (SudokuBoard* self,
                    gint indent)
{
	FILE* _tmp14_;
#line 483 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3885 "sudoku-board.c"
	{
		gint l1 = 0;
#line 485 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3890 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 485 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 485 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3897 "sudoku-board.c"
				FILE* _tmp13_;
#line 485 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3901 "sudoku-board.c"
					gint _tmp1_;
#line 485 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 485 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3907 "sudoku-board.c"
				}
#line 485 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 485 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 485 "../lib/sudoku-board.vala"
					break;
#line 3915 "sudoku-board.c"
				}
				{
					gint i = 0;
#line 487 "../lib/sudoku-board.vala"
					i = 0;
#line 3921 "sudoku-board.c"
					{
						gboolean _tmp2_ = FALSE;
#line 487 "../lib/sudoku-board.vala"
						_tmp2_ = TRUE;
#line 487 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3928 "sudoku-board.c"
							FILE* _tmp4_;
#line 487 "../lib/sudoku-board.vala"
							if (!_tmp2_) {
#line 3932 "sudoku-board.c"
								gint _tmp3_;
#line 487 "../lib/sudoku-board.vala"
								_tmp3_ = i;
#line 487 "../lib/sudoku-board.vala"
								i = _tmp3_ + 1;
#line 3938 "sudoku-board.c"
							}
#line 487 "../lib/sudoku-board.vala"
							_tmp2_ = FALSE;
#line 487 "../lib/sudoku-board.vala"
							if (!(i < indent)) {
#line 487 "../lib/sudoku-board.vala"
								break;
#line 3946 "sudoku-board.c"
							}
#line 488 "../lib/sudoku-board.vala"
							_tmp4_ = stdout;
#line 488 "../lib/sudoku-board.vala"
							fprintf (_tmp4_, " ");
#line 3952 "sudoku-board.c"
						}
					}
				}
				{
					gint l2 = 0;
#line 489 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3960 "sudoku-board.c"
					{
						gboolean _tmp5_ = FALSE;
#line 489 "../lib/sudoku-board.vala"
						_tmp5_ = TRUE;
#line 489 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3967 "sudoku-board.c"
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 489 "../lib/sudoku-board.vala"
							if (!_tmp5_) {
#line 3974 "sudoku-board.c"
								gint _tmp6_;
#line 489 "../lib/sudoku-board.vala"
								_tmp6_ = l2;
#line 489 "../lib/sudoku-board.vala"
								l2 = _tmp6_ + 1;
#line 3980 "sudoku-board.c"
							}
#line 489 "../lib/sudoku-board.vala"
							_tmp5_ = FALSE;
#line 489 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 489 "../lib/sudoku-board.vala"
								break;
#line 3988 "sudoku-board.c"
							}
#line 491 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->cells;
#line 491 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->cells_length1;
#line 491 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->cells_length2;
#line 491 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 491 "../lib/sudoku-board.vala"
							if (_tmp8_ != 0) {
#line 4000 "sudoku-board.c"
								FILE* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
#line 492 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 492 "../lib/sudoku-board.vala"
								_tmp10_ = self->priv->cells;
#line 492 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->priv->cells_length1;
#line 492 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->priv->cells_length2;
#line 492 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(l1 * _tmp10__length2) + l2];
#line 492 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, "%d ", _tmp11_);
#line 4018 "sudoku-board.c"
							} else {
								FILE* _tmp12_;
#line 494 "../lib/sudoku-board.vala"
								_tmp12_ = stdout;
#line 494 "../lib/sudoku-board.vala"
								fprintf (_tmp12_, "  ");
#line 4025 "sudoku-board.c"
							}
						}
					}
				}
#line 496 "../lib/sudoku-board.vala"
				_tmp13_ = stdout;
#line 496 "../lib/sudoku-board.vala"
				fprintf (_tmp13_, "\n");
#line 4034 "sudoku-board.c"
			}
		}
	}
#line 498 "../lib/sudoku-board.vala"
	_tmp14_ = stdout;
#line 498 "../lib/sudoku-board.vala"
	fflush (_tmp14_);
#line 4042 "sudoku-board.c"
}

void
sudoku_board_get_string (SudokuBoard* self)
{
	FILE* _tmp0_;
	FILE* _tmp12_;
#line 501 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 503 "../lib/sudoku-board.vala"
	_tmp0_ = stdout;
#line 503 "../lib/sudoku-board.vala"
	fprintf (_tmp0_, "[ ");
#line 4056 "sudoku-board.c"
	{
		gint l1 = 0;
#line 504 "../lib/sudoku-board.vala"
		l1 = 0;
#line 4061 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 504 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 504 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4068 "sudoku-board.c"
				FILE* _tmp3_;
				FILE* _tmp10_;
#line 504 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4073 "sudoku-board.c"
					gint _tmp2_;
#line 504 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 504 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4079 "sudoku-board.c"
				}
#line 504 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 504 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 504 "../lib/sudoku-board.vala"
					break;
#line 4087 "sudoku-board.c"
				}
#line 506 "../lib/sudoku-board.vala"
				_tmp3_ = stdout;
#line 506 "../lib/sudoku-board.vala"
				fprintf (_tmp3_, "[ ");
#line 4093 "sudoku-board.c"
				{
					gint l2 = 0;
#line 507 "../lib/sudoku-board.vala"
					l2 = 0;
#line 4098 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 507 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 507 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4105 "sudoku-board.c"
							FILE* _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 507 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4113 "sudoku-board.c"
								gint _tmp5_;
#line 507 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 507 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 4119 "sudoku-board.c"
							}
#line 507 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 507 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 507 "../lib/sudoku-board.vala"
								break;
#line 4127 "sudoku-board.c"
							}
#line 509 "../lib/sudoku-board.vala"
							_tmp6_ = stdout;
#line 509 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->cells;
#line 509 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->cells_length1;
#line 509 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->cells_length2;
#line 509 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 509 "../lib/sudoku-board.vala"
							fprintf (_tmp6_, "%d", _tmp8_);
#line 510 "../lib/sudoku-board.vala"
							if (l2 != 8) {
#line 4143 "sudoku-board.c"
								FILE* _tmp9_;
#line 511 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 511 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, ",");
#line 4149 "sudoku-board.c"
							}
						}
					}
				}
#line 513 "../lib/sudoku-board.vala"
				_tmp10_ = stdout;
#line 513 "../lib/sudoku-board.vala"
				fprintf (_tmp10_, " ]");
#line 514 "../lib/sudoku-board.vala"
				if (l1 != 8) {
#line 4160 "sudoku-board.c"
					FILE* _tmp11_;
#line 515 "../lib/sudoku-board.vala"
					_tmp11_ = stdout;
#line 515 "../lib/sudoku-board.vala"
					fprintf (_tmp11_, ",");
#line 4166 "sudoku-board.c"
				}
			}
		}
	}
#line 517 "../lib/sudoku-board.vala"
	_tmp12_ = stdout;
#line 517 "../lib/sudoku-board.vala"
	fprintf (_tmp12_, " ]");
#line 4175 "sudoku-board.c"
}

gchar*
sudoku_board_to_string (SudokuBoard* self,
                        gboolean get_original_state)
{
	gchar* board_string = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 520 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 522 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 522 "../lib/sudoku-board.vala"
	board_string = _tmp0_;
#line 4191 "sudoku-board.c"
	{
		gint i = 0;
#line 523 "../lib/sudoku-board.vala"
		i = 0;
#line 4196 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 523 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 523 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4203 "sudoku-board.c"
				gint _tmp3_;
#line 523 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4207 "sudoku-board.c"
					gint _tmp2_;
#line 523 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 523 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4213 "sudoku-board.c"
				}
#line 523 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 523 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 523 "../lib/sudoku-board.vala"
				if (!(i < _tmp3_)) {
#line 523 "../lib/sudoku-board.vala"
					break;
#line 4223 "sudoku-board.c"
				}
				{
					gint j = 0;
#line 525 "../lib/sudoku-board.vala"
					j = 0;
#line 4229 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 525 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 525 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4236 "sudoku-board.c"
							gint _tmp6_;
							gboolean* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gboolean _tmp8_;
#line 525 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4244 "sudoku-board.c"
								gint _tmp5_;
#line 525 "../lib/sudoku-board.vala"
								_tmp5_ = j;
#line 525 "../lib/sudoku-board.vala"
								j = _tmp5_ + 1;
#line 4250 "sudoku-board.c"
							}
#line 525 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 525 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 525 "../lib/sudoku-board.vala"
							if (!(j < _tmp6_)) {
#line 525 "../lib/sudoku-board.vala"
								break;
#line 4260 "sudoku-board.c"
							}
#line 527 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->is_fixed;
#line 527 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->is_fixed_length1;
#line 527 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->is_fixed_length2;
#line 527 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(i * _tmp7__length2) + j];
#line 527 "../lib/sudoku-board.vala"
							if (_tmp8_) {
#line 4272 "sudoku-board.c"
								const gchar* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
								gchar* _tmp14_;
#line 528 "../lib/sudoku-board.vala"
								_tmp9_ = board_string;
#line 528 "../lib/sudoku-board.vala"
								_tmp10_ = self->priv->cells;
#line 528 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->priv->cells_length1;
#line 528 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->priv->cells_length2;
#line 528 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(i * _tmp10__length2) + j];
#line 528 "../lib/sudoku-board.vala"
								_tmp12_ = g_strdup_printf ("%i", _tmp11_);
#line 528 "../lib/sudoku-board.vala"
								_tmp13_ = _tmp12_;
#line 528 "../lib/sudoku-board.vala"
								_tmp14_ = g_strconcat (_tmp9_, _tmp13_, NULL);
#line 528 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 528 "../lib/sudoku-board.vala"
								board_string = _tmp14_;
#line 528 "../lib/sudoku-board.vala"
								_g_free0 (_tmp13_);
#line 4303 "sudoku-board.c"
							} else {
								gchar* _tmp15_ = NULL;
								const gchar* _tmp20_;
								gchar* _tmp21_;
#line 530 "../lib/sudoku-board.vala"
								if (get_original_state) {
#line 4310 "sudoku-board.c"
									gchar* _tmp16_;
#line 530 "../lib/sudoku-board.vala"
									_tmp16_ = g_strdup ("0");
#line 530 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 530 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp16_;
#line 4318 "sudoku-board.c"
								} else {
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
									gint _tmp18_;
									gchar* _tmp19_;
#line 530 "../lib/sudoku-board.vala"
									_tmp17_ = self->priv->cells;
#line 530 "../lib/sudoku-board.vala"
									_tmp17__length1 = self->priv->cells_length1;
#line 530 "../lib/sudoku-board.vala"
									_tmp17__length2 = self->priv->cells_length2;
#line 530 "../lib/sudoku-board.vala"
									_tmp18_ = _tmp17_[(i * _tmp17__length2) + j];
#line 530 "../lib/sudoku-board.vala"
									_tmp19_ = g_strdup_printf ("%i", _tmp18_);
#line 530 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 530 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp19_;
#line 4339 "sudoku-board.c"
								}
#line 530 "../lib/sudoku-board.vala"
								_tmp20_ = board_string;
#line 530 "../lib/sudoku-board.vala"
								_tmp21_ = g_strconcat (_tmp20_, _tmp15_, NULL);
#line 530 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 530 "../lib/sudoku-board.vala"
								board_string = _tmp21_;
#line 527 "../lib/sudoku-board.vala"
								_g_free0 (_tmp15_);
#line 4351 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 533 "../lib/sudoku-board.vala"
	result = board_string;
#line 533 "../lib/sudoku-board.vala"
	return result;
#line 4363 "sudoku-board.c"
}

static gint*
_vala_array_dup9 (gint* self,
                  gssize length)
{
#line 538 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 538 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 4374 "sudoku-board.c"
	}
#line 538 "../lib/sudoku-board.vala"
	return NULL;
#line 4378 "sudoku-board.c"
}

gint*
sudoku_board_get_cells (SudokuBoard* self,
                        gint* result_length1,
                        gint* result_length2)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint* result;
#line 536 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 538 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 538 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 538 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 538 "../lib/sudoku-board.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup9 (_tmp0_, _tmp0__length1 * _tmp0__length2) : _tmp0_;
#line 538 "../lib/sudoku-board.vala"
	_tmp1__length1 = _tmp0__length1;
#line 538 "../lib/sudoku-board.vala"
	_tmp1__length2 = _tmp0__length2;
#line 538 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 538 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp1__length1;
#line 538 "../lib/sudoku-board.vala"
	_tmp2__length2 = _tmp1__length2;
#line 538 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 538 "../lib/sudoku-board.vala"
		*result_length1 = _tmp2__length1;
#line 4420 "sudoku-board.c"
	}
#line 538 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 538 "../lib/sudoku-board.vala"
		*result_length2 = _tmp2__length2;
#line 4426 "sudoku-board.c"
	}
#line 538 "../lib/sudoku-board.vala"
	result = _tmp2_;
#line 538 "../lib/sudoku-board.vala"
	return result;
#line 4432 "sudoku-board.c"
}

GeeHashMap*
sudoku_board_calculate_open_squares (SudokuBoard* self)
{
	GeeHashMap* possibilities = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result;
#line 541 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 543 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 543 "../lib/sudoku-board.vala"
	possibilities = _tmp0_;
#line 4447 "sudoku-board.c"
	{
		gint l1 = 0;
#line 544 "../lib/sudoku-board.vala"
		l1 = 0;
#line 4452 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 544 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 544 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4459 "sudoku-board.c"
				gint _tmp3_;
#line 544 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4463 "sudoku-board.c"
					gint _tmp2_;
#line 544 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 544 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4469 "sudoku-board.c"
				}
#line 544 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 544 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 544 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp3_)) {
#line 544 "../lib/sudoku-board.vala"
					break;
#line 4479 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 546 "../lib/sudoku-board.vala"
					l2 = 0;
#line 4485 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 546 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 546 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4492 "sudoku-board.c"
							gint _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 546 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4500 "sudoku-board.c"
								gint _tmp5_;
#line 546 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 546 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 4506 "sudoku-board.c"
							}
#line 546 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 546 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 546 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp6_)) {
#line 546 "../lib/sudoku-board.vala"
								break;
#line 4516 "sudoku-board.c"
							}
#line 548 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->cells;
#line 548 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->cells_length1;
#line 548 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->cells_length2;
#line 548 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 548 "../lib/sudoku-board.vala"
							if (_tmp8_ == 0) {
#line 4528 "sudoku-board.c"
								GeeList* possArrayList = NULL;
								GeeArrayList* _tmp9_;
								gint* possArray = NULL;
								gint _tmp10_ = 0;
								gint* _tmp11_;
								gint possArray_length1;
								gint _possArray_size_;
								gint* _tmp12_;
								gint _tmp12__length1;
								GeeHashMap* _tmp14_;
								Coord _tmp15_ = {0};
								GeeList* _tmp16_;
#line 550 "../lib/sudoku-board.vala"
								_tmp9_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 550 "../lib/sudoku-board.vala"
								possArrayList = (GeeList*) _tmp9_;
#line 551 "../lib/sudoku-board.vala"
								_tmp11_ = sudoku_board_get_possibilities (self, l1, l2, &_tmp10_);
#line 551 "../lib/sudoku-board.vala"
								possArray = _tmp11_;
#line 551 "../lib/sudoku-board.vala"
								possArray_length1 = _tmp10_;
#line 551 "../lib/sudoku-board.vala"
								_possArray_size_ = possArray_length1;
#line 552 "../lib/sudoku-board.vala"
								_tmp12_ = possArray;
#line 552 "../lib/sudoku-board.vala"
								_tmp12__length1 = possArray_length1;
#line 4557 "sudoku-board.c"
								{
									gint* i_collection = NULL;
									gint i_collection_length1 = 0;
									gint _i_collection_size_ = 0;
									gint i_it = 0;
#line 552 "../lib/sudoku-board.vala"
									i_collection = _tmp12_;
#line 552 "../lib/sudoku-board.vala"
									i_collection_length1 = _tmp12__length1;
#line 552 "../lib/sudoku-board.vala"
									for (i_it = 0; i_it < i_collection_length1; i_it = i_it + 1) {
#line 4569 "sudoku-board.c"
										gint i = 0;
#line 552 "../lib/sudoku-board.vala"
										i = i_collection[i_it];
#line 4573 "sudoku-board.c"
										{
											GeeList* _tmp13_;
#line 553 "../lib/sudoku-board.vala"
											_tmp13_ = possArrayList;
#line 553 "../lib/sudoku-board.vala"
											gee_collection_add ((GeeCollection*) _tmp13_, (gpointer) ((gintptr) i));
#line 4580 "sudoku-board.c"
										}
									}
								}
#line 554 "../lib/sudoku-board.vala"
								_tmp14_ = possibilities;
#line 554 "../lib/sudoku-board.vala"
								coord_init (&_tmp15_, l1, l2);
#line 554 "../lib/sudoku-board.vala"
								_tmp16_ = possArrayList;
#line 554 "../lib/sudoku-board.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, &_tmp15_, _tmp16_);
#line 548 "../lib/sudoku-board.vala"
								possArray = (g_free (possArray), NULL);
#line 548 "../lib/sudoku-board.vala"
								_g_object_unref0 (possArrayList);
#line 4596 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 558 "../lib/sudoku-board.vala"
	result = possibilities;
#line 558 "../lib/sudoku-board.vala"
	return result;
#line 4608 "sudoku-board.c"
}

gboolean
sudoku_board_is_finished (SudokuBoard* self)
{
	gchar* board_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* finishgame_file = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* file = NULL;
	GFile* _tmp7_;
	gboolean result;
#line 561 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 563 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_to_string (self, TRUE);
#line 563 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 563 "../lib/sudoku-board.vala"
	_tmp2_ = g_strconcat (_tmp1_, ".save", NULL);
#line 563 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 563 "../lib/sudoku-board.vala"
	_g_free0 (_tmp1_);
#line 563 "../lib/sudoku-board.vala"
	board_string = _tmp3_;
#line 564 "../lib/sudoku-board.vala"
	_tmp4_ = sudoku_saver_get_finishgame_dir ();
#line 564 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 564 "../lib/sudoku-board.vala"
	_tmp6_ = g_build_path (G_DIR_SEPARATOR_S, _tmp5_, board_string, NULL);
#line 564 "../lib/sudoku-board.vala"
	finishgame_file = _tmp6_;
#line 565 "../lib/sudoku-board.vala"
	_tmp7_ = g_file_new_for_path (finishgame_file);
#line 565 "../lib/sudoku-board.vala"
	file = _tmp7_;
#line 567 "../lib/sudoku-board.vala"
	result = g_file_query_exists (file, NULL);
#line 567 "../lib/sudoku-board.vala"
	_g_object_unref0 (file);
#line 567 "../lib/sudoku-board.vala"
	_g_free0 (finishgame_file);
#line 567 "../lib/sudoku-board.vala"
	_g_free0 (board_string);
#line 567 "../lib/sudoku-board.vala"
	return result;
#line 4662 "sudoku-board.c"
}

gboolean*
sudoku_board_get_earmarks (SudokuBoard* self,
                           gint row,
                           gint col,
                           gint* result_length1)
{
	gboolean* the_earmarks = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint the_earmarks_length1;
	gint _the_earmarks_size_;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gboolean* result;
#line 570 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 572 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 572 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 572 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 572 "../lib/sudoku-board.vala"
	the_earmarks = _tmp2_;
#line 572 "../lib/sudoku-board.vala"
	the_earmarks_length1 = _tmp1_;
#line 572 "../lib/sudoku-board.vala"
	_the_earmarks_size_ = the_earmarks_length1;
#line 4694 "sudoku-board.c"
	{
		gint i = 0;
#line 573 "../lib/sudoku-board.vala"
		i = 1;
#line 4699 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 573 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 573 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4706 "sudoku-board.c"
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
				gboolean* _tmp8_;
				gint _tmp8__length1;
				gint _tmp8__length2;
				gint _tmp8__length3;
				gboolean _tmp9_;
#line 573 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 4718 "sudoku-board.c"
					gint _tmp4_;
#line 573 "../lib/sudoku-board.vala"
					_tmp4_ = i;
#line 573 "../lib/sudoku-board.vala"
					i = _tmp4_ + 1;
#line 4724 "sudoku-board.c"
				}
#line 573 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 573 "../lib/sudoku-board.vala"
				_tmp5_ = sudoku_board_get_max_val (self);
#line 573 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_;
#line 573 "../lib/sudoku-board.vala"
				if (!(i <= _tmp6_)) {
#line 573 "../lib/sudoku-board.vala"
					break;
#line 4736 "sudoku-board.c"
				}
#line 574 "../lib/sudoku-board.vala"
				_tmp7_ = the_earmarks;
#line 574 "../lib/sudoku-board.vala"
				_tmp7__length1 = the_earmarks_length1;
#line 574 "../lib/sudoku-board.vala"
				_tmp8_ = self->priv->earmarks;
#line 574 "../lib/sudoku-board.vala"
				_tmp8__length1 = self->priv->earmarks_length1;
#line 574 "../lib/sudoku-board.vala"
				_tmp8__length2 = self->priv->earmarks_length2;
#line 574 "../lib/sudoku-board.vala"
				_tmp8__length3 = self->priv->earmarks_length3;
#line 574 "../lib/sudoku-board.vala"
				_tmp9_ = _tmp8_[(((row * _tmp8__length2) + col) * _tmp8__length3) + (i - 1)];
#line 574 "../lib/sudoku-board.vala"
				_tmp7_[i - 1] = _tmp9_;
#line 4754 "sudoku-board.c"
			}
		}
	}
#line 575 "../lib/sudoku-board.vala"
	_tmp10_ = the_earmarks;
#line 575 "../lib/sudoku-board.vala"
	_tmp10__length1 = the_earmarks_length1;
#line 575 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 575 "../lib/sudoku-board.vala"
		*result_length1 = _tmp10__length1;
#line 4766 "sudoku-board.c"
	}
#line 575 "../lib/sudoku-board.vala"
	result = _tmp10_;
#line 575 "../lib/sudoku-board.vala"
	return result;
#line 4772 "sudoku-board.c"
}

gboolean
sudoku_board_has_earmarks (SudokuBoard* self,
                           gint row,
                           gint col)
{
	gboolean* current_earmarks = NULL;
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gint current_earmarks_length1;
	gint _current_earmarks_size_;
	gboolean has_earmarks = FALSE;
	gboolean result;
#line 578 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 580 "../lib/sudoku-board.vala"
	_tmp1_ = sudoku_board_get_earmarks (self, row, col, &_tmp0_);
#line 580 "../lib/sudoku-board.vala"
	current_earmarks = _tmp1_;
#line 580 "../lib/sudoku-board.vala"
	current_earmarks_length1 = _tmp0_;
#line 580 "../lib/sudoku-board.vala"
	_current_earmarks_size_ = current_earmarks_length1;
#line 581 "../lib/sudoku-board.vala"
	has_earmarks = FALSE;
#line 4799 "sudoku-board.c"
	{
		gint i = 0;
#line 582 "../lib/sudoku-board.vala"
		i = 0;
#line 4804 "sudoku-board.c"
		{
			gboolean _tmp2_ = FALSE;
#line 582 "../lib/sudoku-board.vala"
			_tmp2_ = TRUE;
#line 582 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4811 "sudoku-board.c"
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gboolean _tmp5_;
#line 582 "../lib/sudoku-board.vala"
				if (!_tmp2_) {
#line 4817 "sudoku-board.c"
					gint _tmp3_;
#line 582 "../lib/sudoku-board.vala"
					_tmp3_ = i;
#line 582 "../lib/sudoku-board.vala"
					i = _tmp3_ + 1;
#line 4823 "sudoku-board.c"
				}
#line 582 "../lib/sudoku-board.vala"
				_tmp2_ = FALSE;
#line 582 "../lib/sudoku-board.vala"
				if (!(i < 9)) {
#line 582 "../lib/sudoku-board.vala"
					break;
#line 4831 "sudoku-board.c"
				}
#line 583 "../lib/sudoku-board.vala"
				_tmp4_ = current_earmarks;
#line 583 "../lib/sudoku-board.vala"
				_tmp4__length1 = current_earmarks_length1;
#line 583 "../lib/sudoku-board.vala"
				_tmp5_ = _tmp4_[i];
#line 583 "../lib/sudoku-board.vala"
				if (_tmp5_) {
#line 585 "../lib/sudoku-board.vala"
					has_earmarks = TRUE;
#line 586 "../lib/sudoku-board.vala"
					break;
#line 4845 "sudoku-board.c"
				}
			}
		}
	}
#line 588 "../lib/sudoku-board.vala"
	result = has_earmarks;
#line 588 "../lib/sudoku-board.vala"
	current_earmarks = (g_free (current_earmarks), NULL);
#line 588 "../lib/sudoku-board.vala"
	return result;
#line 4856 "sudoku-board.c"
}

gchar*
sudoku_board_get_earmarks_string (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 591 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 593 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 593 "../lib/sudoku-board.vala"
	s = _tmp0_;
#line 4873 "sudoku-board.c"
	{
		gint i = 0;
#line 594 "../lib/sudoku-board.vala"
		i = 1;
#line 4878 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 594 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 594 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4885 "sudoku-board.c"
				gint _tmp3_;
				gint _tmp4_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				gint _tmp5__length3;
				gboolean _tmp6_;
#line 594 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4895 "sudoku-board.c"
					gint _tmp2_;
#line 594 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 594 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4901 "sudoku-board.c"
				}
#line 594 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 594 "../lib/sudoku-board.vala"
				_tmp3_ = sudoku_board_get_max_val (self);
#line 594 "../lib/sudoku-board.vala"
				_tmp4_ = _tmp3_;
#line 594 "../lib/sudoku-board.vala"
				if (!(i <= _tmp4_)) {
#line 594 "../lib/sudoku-board.vala"
					break;
#line 4913 "sudoku-board.c"
				}
#line 595 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->earmarks;
#line 595 "../lib/sudoku-board.vala"
				_tmp5__length1 = self->priv->earmarks_length1;
#line 595 "../lib/sudoku-board.vala"
				_tmp5__length2 = self->priv->earmarks_length2;
#line 595 "../lib/sudoku-board.vala"
				_tmp5__length3 = self->priv->earmarks_length3;
#line 595 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_[(((row * _tmp5__length2) + col) * _tmp5__length3) + (i - 1)];
#line 595 "../lib/sudoku-board.vala"
				if (_tmp6_) {
#line 4927 "sudoku-board.c"
					const gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 596 "../lib/sudoku-board.vala"
					_tmp7_ = s;
#line 596 "../lib/sudoku-board.vala"
					_tmp8_ = g_strdup_printf ("%i", i);
#line 596 "../lib/sudoku-board.vala"
					_tmp9_ = _tmp8_;
#line 596 "../lib/sudoku-board.vala"
					_tmp10_ = g_strconcat (_tmp7_, _tmp9_, NULL);
#line 596 "../lib/sudoku-board.vala"
					_g_free0 (s);
#line 596 "../lib/sudoku-board.vala"
					s = _tmp10_;
#line 596 "../lib/sudoku-board.vala"
					_g_free0 (_tmp9_);
#line 4946 "sudoku-board.c"
				}
			}
		}
	}
#line 598 "../lib/sudoku-board.vala"
	result = s;
#line 598 "../lib/sudoku-board.vala"
	return result;
#line 4955 "sudoku-board.c"
}

static gint*
sudoku_board_convert_2d_to_1d (SudokuBoard* self,
                               gint* ints_2d,
                               gint ints_2d_length1,
                               gint ints_2d_length2,
                               gint* result_length1)
{
	gint* ints_1d = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint ints_1d_length1;
	gint _ints_1d_size_;
	gint i = 0;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint* result;
#line 603 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 605 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 605 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 605 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 605 "../lib/sudoku-board.vala"
	ints_1d = _tmp2_;
#line 605 "../lib/sudoku-board.vala"
	ints_1d_length1 = _tmp0_ * _tmp1_;
#line 605 "../lib/sudoku-board.vala"
	_ints_1d_size_ = ints_1d_length1;
#line 606 "../lib/sudoku-board.vala"
	i = 0;
#line 4991 "sudoku-board.c"
	{
		gint row = 0;
#line 607 "../lib/sudoku-board.vala"
		row = 0;
#line 4996 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 607 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 607 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 5003 "sudoku-board.c"
				gint _tmp5_;
#line 607 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 5007 "sudoku-board.c"
					gint _tmp4_;
#line 607 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 607 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 5013 "sudoku-board.c"
				}
#line 607 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 607 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 607 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 607 "../lib/sudoku-board.vala"
					break;
#line 5023 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 608 "../lib/sudoku-board.vala"
					col = 0;
#line 5029 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 608 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 608 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 5036 "sudoku-board.c"
							gint _tmp8_;
							gint* _tmp9_;
							gint _tmp9__length1;
							gint _tmp10_;
							gint _tmp11_;
#line 608 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 5044 "sudoku-board.c"
								gint _tmp7_;
#line 608 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 608 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 5050 "sudoku-board.c"
							}
#line 608 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 608 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 608 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 608 "../lib/sudoku-board.vala"
								break;
#line 5060 "sudoku-board.c"
							}
#line 609 "../lib/sudoku-board.vala"
							_tmp9_ = ints_1d;
#line 609 "../lib/sudoku-board.vala"
							_tmp9__length1 = ints_1d_length1;
#line 609 "../lib/sudoku-board.vala"
							_tmp10_ = i;
#line 609 "../lib/sudoku-board.vala"
							i = _tmp10_ + 1;
#line 609 "../lib/sudoku-board.vala"
							_tmp11_ = ints_2d[(row * ints_2d_length2) + col];
#line 609 "../lib/sudoku-board.vala"
							_tmp9_[_tmp10_] = _tmp11_;
#line 5074 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 610 "../lib/sudoku-board.vala"
	_tmp12_ = ints_1d;
#line 610 "../lib/sudoku-board.vala"
	_tmp12__length1 = ints_1d_length1;
#line 610 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 610 "../lib/sudoku-board.vala"
		*result_length1 = _tmp12__length1;
#line 5089 "sudoku-board.c"
	}
#line 610 "../lib/sudoku-board.vala"
	result = _tmp12_;
#line 610 "../lib/sudoku-board.vala"
	return result;
#line 5095 "sudoku-board.c"
}

static gint*
sudoku_board_convert_1d_to_2d (SudokuBoard* self,
                               gint* ints_1d,
                               gint ints_1d_length1,
                               gint* result_length1,
                               gint* result_length2)
{
	gint* ints_2d = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint ints_2d_length1;
	gint ints_2d_length2;
	gint i = 0;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gint* result;
#line 615 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 617 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 617 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 617 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 617 "../lib/sudoku-board.vala"
	ints_2d = _tmp2_;
#line 617 "../lib/sudoku-board.vala"
	ints_2d_length1 = _tmp0_;
#line 617 "../lib/sudoku-board.vala"
	ints_2d_length2 = _tmp1_;
#line 618 "../lib/sudoku-board.vala"
	i = 0;
#line 5132 "sudoku-board.c"
	{
		gint row = 0;
#line 619 "../lib/sudoku-board.vala"
		row = 0;
#line 5137 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 619 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 619 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 5144 "sudoku-board.c"
				gint _tmp5_;
#line 619 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 5148 "sudoku-board.c"
					gint _tmp4_;
#line 619 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 619 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 5154 "sudoku-board.c"
				}
#line 619 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 619 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 619 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 619 "../lib/sudoku-board.vala"
					break;
#line 5164 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 620 "../lib/sudoku-board.vala"
					col = 0;
#line 5170 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 620 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 620 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 5177 "sudoku-board.c"
							gint _tmp8_;
							gint* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gint _tmp10_;
							gint _tmp11_;
#line 620 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 5186 "sudoku-board.c"
								gint _tmp7_;
#line 620 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 620 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 5192 "sudoku-board.c"
							}
#line 620 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 620 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 620 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 620 "../lib/sudoku-board.vala"
								break;
#line 5202 "sudoku-board.c"
							}
#line 621 "../lib/sudoku-board.vala"
							_tmp9_ = ints_2d;
#line 621 "../lib/sudoku-board.vala"
							_tmp9__length1 = ints_2d_length1;
#line 621 "../lib/sudoku-board.vala"
							_tmp9__length2 = ints_2d_length2;
#line 621 "../lib/sudoku-board.vala"
							_tmp10_ = i;
#line 621 "../lib/sudoku-board.vala"
							i = _tmp10_ + 1;
#line 621 "../lib/sudoku-board.vala"
							_tmp11_ = ints_1d[_tmp10_];
#line 621 "../lib/sudoku-board.vala"
							_tmp9_[(row * _tmp9__length2) + col] = _tmp11_;
#line 5218 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 622 "../lib/sudoku-board.vala"
	_tmp12_ = ints_2d;
#line 622 "../lib/sudoku-board.vala"
	_tmp12__length1 = ints_2d_length1;
#line 622 "../lib/sudoku-board.vala"
	_tmp12__length2 = ints_2d_length2;
#line 622 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 622 "../lib/sudoku-board.vala"
		*result_length1 = _tmp12__length1;
#line 5235 "sudoku-board.c"
	}
#line 622 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 622 "../lib/sudoku-board.vala"
		*result_length2 = _tmp12__length2;
#line 5241 "sudoku-board.c"
	}
#line 622 "../lib/sudoku-board.vala"
	result = _tmp12_;
#line 622 "../lib/sudoku-board.vala"
	return result;
#line 5247 "sudoku-board.c"
}

gdouble
sudoku_board_get_previous_played_time (SudokuBoard* self)
{
	gdouble result;
#line 42 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 42 "../lib/sudoku-board.vala"
	result = self->priv->_previous_played_time;
#line 42 "../lib/sudoku-board.vala"
	return result;
#line 5260 "sudoku-board.c"
}

void
sudoku_board_set_previous_played_time (SudokuBoard* self,
                                       gdouble value)
{
	gdouble old_value;
#line 42 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 42 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_previous_played_time (self);
#line 42 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 42 "../lib/sudoku-board.vala"
		self->priv->_previous_played_time = value;
#line 42 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY]);
#line 5278 "sudoku-board.c"
	}
}

DifficultyCategory
sudoku_board_get_difficulty_category (SudokuBoard* self)
{
	DifficultyCategory result;
#line 44 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../lib/sudoku-board.vala"
	result = self->priv->_difficulty_category;
#line 44 "../lib/sudoku-board.vala"
	return result;
#line 5292 "sudoku-board.c"
}

void
sudoku_board_set_difficulty_category (SudokuBoard* self,
                                      DifficultyCategory value)
{
	DifficultyCategory old_value;
#line 44 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 44 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_difficulty_category (self);
#line 44 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 44 "../lib/sudoku-board.vala"
		self->priv->_difficulty_category = value;
#line 44 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY]);
#line 5310 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_rows (SudokuBoard* self)
{
	gint result;
#line 47 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../lib/sudoku-board.vala"
	result = self->priv->_block_rows;
#line 47 "../lib/sudoku-board.vala"
	return result;
#line 5324 "sudoku-board.c"
}

static void
sudoku_board_set_block_rows (SudokuBoard* self,
                             gint value)
{
	gint old_value;
#line 47 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 47 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_block_rows (self);
#line 47 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 47 "../lib/sudoku-board.vala"
		self->priv->_block_rows = value;
#line 47 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY]);
#line 5342 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_cols (SudokuBoard* self)
{
	gint result;
#line 50 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 50 "../lib/sudoku-board.vala"
	result = self->priv->_block_cols;
#line 50 "../lib/sudoku-board.vala"
	return result;
#line 5356 "sudoku-board.c"
}

static void
sudoku_board_set_block_cols (SudokuBoard* self,
                             gint value)
{
	gint old_value;
#line 50 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 50 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_block_cols (self);
#line 50 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 50 "../lib/sudoku-board.vala"
		self->priv->_block_cols = value;
#line 50 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY]);
#line 5374 "sudoku-board.c"
	}
}

gint
sudoku_board_get_rows (SudokuBoard* self)
{
	gint result;
#line 53 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../lib/sudoku-board.vala"
	result = self->priv->_rows;
#line 53 "../lib/sudoku-board.vala"
	return result;
#line 5388 "sudoku-board.c"
}

static void
sudoku_board_set_rows (SudokuBoard* self,
                       gint value)
{
	gint old_value;
#line 53 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 53 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_rows (self);
#line 53 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 53 "../lib/sudoku-board.vala"
		self->priv->_rows = value;
#line 53 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY]);
#line 5406 "sudoku-board.c"
	}
}

gint
sudoku_board_get_cols (SudokuBoard* self)
{
	gint result;
#line 56 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "../lib/sudoku-board.vala"
	result = self->priv->_cols;
#line 56 "../lib/sudoku-board.vala"
	return result;
#line 5420 "sudoku-board.c"
}

static void
sudoku_board_set_cols (SudokuBoard* self,
                       gint value)
{
	gint old_value;
#line 56 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 56 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_cols (self);
#line 56 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 56 "../lib/sudoku-board.vala"
		self->priv->_cols = value;
#line 56 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY]);
#line 5438 "sudoku-board.c"
	}
}

gint
sudoku_board_get_max_val (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 61 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 61 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 61 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 61 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 61 "../lib/sudoku-board.vala"
	return result;
#line 5458 "sudoku-board.c"
}

gboolean
sudoku_board_get_broken (SudokuBoard* self)
{
	gboolean result;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 66 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 66 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_broken_coords;
#line 66 "../lib/sudoku-board.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 66 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 66 "../lib/sudoku-board.vala"
	result = _tmp2_ != 0;
#line 66 "../lib/sudoku-board.vala"
	return result;
#line 5480 "sudoku-board.c"
}

gint
sudoku_board_get_filled (SudokuBoard* self)
{
	gint result;
#line 70 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 70 "../lib/sudoku-board.vala"
	result = self->priv->_filled;
#line 70 "../lib/sudoku-board.vala"
	return result;
#line 5493 "sudoku-board.c"
}

static void
sudoku_board_set_filled (SudokuBoard* self,
                         gint value)
{
	gint old_value;
#line 70 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 70 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_filled (self);
#line 70 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 70 "../lib/sudoku-board.vala"
		self->priv->_filled = value;
#line 70 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY]);
#line 5511 "sudoku-board.c"
	}
}

gint
sudoku_board_get_fixed (SudokuBoard* self)
{
	gint result;
#line 73 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../lib/sudoku-board.vala"
	result = self->priv->_fixed;
#line 73 "../lib/sudoku-board.vala"
	return result;
#line 5525 "sudoku-board.c"
}

static void
sudoku_board_set_fixed (SudokuBoard* self,
                        gint value)
{
	gint old_value;
#line 73 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 73 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_fixed (self);
#line 73 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 73 "../lib/sudoku-board.vala"
		self->priv->_fixed = value;
#line 73 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY]);
#line 5543 "sudoku-board.c"
	}
}

gint
sudoku_board_get_size (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 77 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 77 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 77 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 77 "../lib/sudoku-board.vala"
	return result;
#line 5563 "sudoku-board.c"
}

gboolean
sudoku_board_get_complete (SudokuBoard* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 93 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 93 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_cols;
#line 93 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 93 "../lib/sudoku-board.vala"
	if (_tmp1_ == (_tmp2_ * _tmp3_)) {
#line 5584 "sudoku-board.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 93 "../lib/sudoku-board.vala"
		_tmp4_ = sudoku_board_get_broken (self);
#line 93 "../lib/sudoku-board.vala"
		_tmp5_ = _tmp4_;
#line 93 "../lib/sudoku-board.vala"
		_tmp0_ = !_tmp5_;
#line 5593 "sudoku-board.c"
	} else {
#line 93 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5597 "sudoku-board.c"
	}
#line 93 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 93 "../lib/sudoku-board.vala"
	return result;
#line 5603 "sudoku-board.c"
}

GeeSet*
sudoku_board_get_broken_coords (SudokuBoard* self)
{
	GeeSet* result;
	GeeSet* _tmp0_;
#line 111 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_broken_coords;
#line 111 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 111 "../lib/sudoku-board.vala"
	return result;
#line 5619 "sudoku-board.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "../lib/sudoku-board.vala"
	return self ? g_object_ref (self) : NULL;
#line 5627 "sudoku-board.c"
}

static void
sudoku_board_set_broken_coords (SudokuBoard* self,
                                GeeSet* value)
{
	GeeSet* old_value;
#line 111 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 111 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_broken_coords (self);
#line 111 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5641 "sudoku-board.c"
		GeeSet* _tmp0_;
#line 111 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 111 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_broken_coords);
#line 111 "../lib/sudoku-board.vala"
		self->priv->_broken_coords = _tmp0_;
#line 111 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BROKEN_COORDS_PROPERTY]);
#line 5651 "sudoku-board.c"
	}
}

GeeList*
sudoku_board_get_coords_for_col (SudokuBoard* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 114 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 114 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_col;
#line 114 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 114 "../lib/sudoku-board.vala"
	return result;
#line 5668 "sudoku-board.c"
}

static void
sudoku_board_set_coords_for_col (SudokuBoard* self,
                                 GeeList* value)
{
	GeeList* old_value;
#line 114 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 114 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_coords_for_col (self);
#line 114 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5682 "sudoku-board.c"
		GeeList* _tmp0_;
#line 114 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 114 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_coords_for_col);
#line 114 "../lib/sudoku-board.vala"
		self->priv->_coords_for_col = _tmp0_;
#line 114 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY]);
#line 5692 "sudoku-board.c"
	}
}

GeeList*
sudoku_board_get_coords_for_row (SudokuBoard* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 117 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_row;
#line 117 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 117 "../lib/sudoku-board.vala"
	return result;
#line 5709 "sudoku-board.c"
}

static void
sudoku_board_set_coords_for_row (SudokuBoard* self,
                                 GeeList* value)
{
	GeeList* old_value;
#line 117 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 117 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_coords_for_row (self);
#line 117 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5723 "sudoku-board.c"
		GeeList* _tmp0_;
#line 117 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 117 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_coords_for_row);
#line 117 "../lib/sudoku-board.vala"
		self->priv->_coords_for_row = _tmp0_;
#line 117 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY]);
#line 5733 "sudoku-board.c"
	}
}

GeeMap*
sudoku_board_get_coords_for_block (SudokuBoard* self)
{
	GeeMap* result;
	GeeMap* _tmp0_;
#line 120 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_block;
#line 120 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 120 "../lib/sudoku-board.vala"
	return result;
#line 5750 "sudoku-board.c"
}

static void
sudoku_board_set_coords_for_block (SudokuBoard* self,
                                   GeeMap* value)
{
	GeeMap* old_value;
#line 120 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 120 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_coords_for_block (self);
#line 120 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5764 "sudoku-board.c"
		GeeMap* _tmp0_;
#line 120 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 120 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_coords_for_block);
#line 120 "../lib/sudoku-board.vala"
		self->priv->_coords_for_block = _tmp0_;
#line 120 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY]);
#line 5774 "sudoku-board.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_BOOLEAN) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gboolean arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../lib/sudoku-board.vala"
	g_return_if_fail (n_param_values == 5);
#line 24 "../lib/sudoku-board.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../lib/sudoku-board.vala"
		data1 = closure->data;
#line 24 "../lib/sudoku-board.vala"
		data2 = param_values->data[0].v_pointer;
#line 5800 "sudoku-board.c"
	} else {
#line 24 "../lib/sudoku-board.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../lib/sudoku-board.vala"
		data2 = closure->data;
#line 5806 "sudoku-board.c"
	}
#line 24 "../lib/sudoku-board.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 24 "../lib/sudoku-board.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_boolean (param_values + 4), data2);
#line 5812 "sudoku-board.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../lib/sudoku-board.vala"
	g_return_if_fail (n_param_values == 5);
#line 24 "../lib/sudoku-board.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../lib/sudoku-board.vala"
		data1 = closure->data;
#line 24 "../lib/sudoku-board.vala"
		data2 = param_values->data[0].v_pointer;
#line 5837 "sudoku-board.c"
	} else {
#line 24 "../lib/sudoku-board.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../lib/sudoku-board.vala"
		data2 = closure->data;
#line 5843 "sudoku-board.c"
	}
#line 24 "../lib/sudoku-board.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 24 "../lib/sudoku-board.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 5849 "sudoku-board.c"
}

static void
sudoku_board_class_init (SudokuBoardClass * klass,
                         gpointer klass_data)
{
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-board.vala"
	g_type_class_adjust_private_offset (klass, &SudokuBoard_private_offset);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_board_get_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_board_set_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_board_finalize;
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY] = g_param_spec_double ("previous-played-time", "previous-played-time", "previous-played-time", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY] = g_param_spec_enum ("difficulty-category", "difficulty-category", "difficulty-category", TYPE_DIFFICULTY_CATEGORY, DIFFICULTY_CATEGORY_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY] = g_param_spec_int ("block-rows", "block-rows", "block-rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY] = g_param_spec_int ("block-cols", "block-cols", "block-cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY] = g_param_spec_int ("cols", "cols", "cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_MAX_VAL_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_MAX_VAL_PROPERTY] = g_param_spec_int ("max-val", "max-val", "max-val", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BROKEN_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BROKEN_PROPERTY] = g_param_spec_boolean ("broken", "broken", "broken", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FILLED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY] = g_param_spec_int ("filled", "filled", "filled", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FIXED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY] = g_param_spec_int ("fixed", "fixed", "fixed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_SIZE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COMPLETE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COMPLETE_PROPERTY] = g_param_spec_boolean ("complete", "complete", "complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BROKEN_COORDS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BROKEN_COORDS_PROPERTY] = g_param_spec_object ("broken-coords", "broken-coords", "broken-coords", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY] = g_param_spec_object ("coords-for-col", "coords-for-col", "coords-for-col", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY] = g_param_spec_object ("coords-for-row", "coords-for-row", "coords-for-row", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY] = g_param_spec_object ("coords-for-block", "coords-for-block", "coords-for-block", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL] = g_signal_new ("completed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_signals[SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL] = g_signal_new ("earmark-changed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_BOOLEAN, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_BOOLEAN);
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_signals[SUDOKU_BOARD_CELL_CHANGED_SIGNAL] = g_signal_new ("cell-changed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 5904 "sudoku-board.c"
}

static void
sudoku_board_instance_init (SudokuBoard * self,
                            gpointer klass)
{
#line 24 "../lib/sudoku-board.vala"
	self->priv = sudoku_board_get_instance_private (self);
#line 42 "../lib/sudoku-board.vala"
	self->priv->_previous_played_time = (gdouble) 0;
#line 44 "../lib/sudoku-board.vala"
	self->priv->_difficulty_category = DIFFICULTY_CATEGORY_UNKNOWN;
#line 5917 "sudoku-board.c"
}

static void
sudoku_board_finalize (GObject * obj)
{
	SudokuBoard * self;
#line 24 "../lib/sudoku-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 29 "../lib/sudoku-board.vala"
	self->priv->cells = (g_free (self->priv->cells), NULL);
#line 30 "../lib/sudoku-board.vala"
	self->priv->solution = (g_free (self->priv->solution), NULL);
#line 31 "../lib/sudoku-board.vala"
	self->priv->is_fixed = (g_free (self->priv->is_fixed), NULL);
#line 34 "../lib/sudoku-board.vala"
	self->priv->occurences_in_row = (g_free (self->priv->occurences_in_row), NULL);
#line 35 "../lib/sudoku-board.vala"
	self->priv->occurences_in_col = (g_free (self->priv->occurences_in_col), NULL);
#line 36 "../lib/sudoku-board.vala"
	self->priv->occurences_in_block = (g_free (self->priv->occurences_in_block), NULL);
#line 39 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 111 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_broken_coords);
#line 114 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_coords_for_col);
#line 117 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_coords_for_row);
#line 120 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_coords_for_block);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (sudoku_board_parent_class)->finalize (obj);
#line 5950 "sudoku-board.c"
}

static GType
sudoku_board_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuBoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuBoard), 0, (GInstanceInitFunc) sudoku_board_instance_init, NULL };
	GType sudoku_board_type_id;
	sudoku_board_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuBoard", &g_define_type_info, 0);
	SudokuBoard_private_offset = g_type_add_instance_private (sudoku_board_type_id, sizeof (SudokuBoardPrivate));
	return sudoku_board_type_id;
}

GType
sudoku_board_get_type (void)
{
	static volatile gsize sudoku_board_type_id__once = 0;
	if (g_once_init_enter (&sudoku_board_type_id__once)) {
		GType sudoku_board_type_id;
		sudoku_board_type_id = sudoku_board_get_type_once ();
		g_once_init_leave (&sudoku_board_type_id__once, sudoku_board_type_id);
	}
	return sudoku_board_type_id__once;
}

static void
_vala_sudoku_board_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_double (value, sudoku_board_get_previous_played_time (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_enum (value, sudoku_board_get_difficulty_category (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_MAX_VAL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_max_val (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_broken (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_filled (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_fixed (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_SIZE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_size (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COMPLETE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_complete (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_COORDS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_broken_coords (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_coords_for_col (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_coords_for_row (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_coords_for_block (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6081 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6087 "sudoku-board.c"
	}
}

static void
_vala_sudoku_board_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_previous_played_time (self, g_value_get_double (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_difficulty_category (self, g_value_get_enum (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_filled (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_COORDS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_broken_coords (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_coords_for_col (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_coords_for_row (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_coords_for_block (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6173 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6179 "sudoku-board.c"
	}
}

static GType
house_get_type_once (void)
{
	static const GEnumValue values[] = {{HOUSE_ROW, "HOUSE_ROW", "row"}, {HOUSE_COLUMN, "HOUSE_COLUMN", "column"}, {HOUSE_BLOCK, "HOUSE_BLOCK", "block"}, {0, NULL, NULL}};
	GType house_type_id;
	house_type_id = g_enum_register_static ("House", values);
	return house_type_id;
}

GType
house_get_type (void)
{
	static volatile gsize house_type_id__once = 0;
	if (g_once_init_enter (&house_type_id__once)) {
		GType house_type_id;
		house_type_id = house_get_type_once ();
		g_once_init_leave (&house_type_id__once, house_type_id);
	}
	return house_type_id__once;
}

void
coord_init (Coord *self,
            gint row,
            gint col)
{
#line 638 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Coord));
#line 640 "../lib/sudoku-board.vala"
	(*self).row = row;
#line 641 "../lib/sudoku-board.vala"
	(*self).col = col;
#line 6215 "sudoku-board.c"
}

gint
coord_hash (Coord* coord)
{
	Coord _tmp0_;
	Coord _tmp1_;
	gint result;
#line 644 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coord != NULL, 0);
#line 646 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 646 "../lib/sudoku-board.vala"
	_tmp1_ = *coord;
#line 646 "../lib/sudoku-board.vala"
	result = (_tmp0_.row * 33) ^ _tmp1_.col;
#line 646 "../lib/sudoku-board.vala"
	return result;
#line 6234 "sudoku-board.c"
}

gboolean
coord_equal (Coord* a,
             Coord* b)
{
	gboolean _tmp0_ = FALSE;
	Coord _tmp1_;
	Coord _tmp2_;
	gboolean result;
#line 649 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 649 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 651 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 651 "../lib/sudoku-board.vala"
	_tmp2_ = *b;
#line 651 "../lib/sudoku-board.vala"
	if (_tmp1_.row == _tmp2_.row) {
#line 6255 "sudoku-board.c"
		Coord _tmp3_;
		Coord _tmp4_;
#line 651 "../lib/sudoku-board.vala"
		_tmp3_ = *a;
#line 651 "../lib/sudoku-board.vala"
		_tmp4_ = *b;
#line 651 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp3_.col == _tmp4_.col;
#line 6264 "sudoku-board.c"
	} else {
#line 651 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 6268 "sudoku-board.c"
	}
#line 651 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 651 "../lib/sudoku-board.vala"
	return result;
#line 6274 "sudoku-board.c"
}

Coord*
coord_dup (const Coord* self)
{
	Coord* dup;
#line 633 "../lib/sudoku-board.vala"
	dup = g_new0 (Coord, 1);
#line 633 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Coord));
#line 633 "../lib/sudoku-board.vala"
	return dup;
#line 6287 "sudoku-board.c"
}

void
coord_free (Coord* self)
{
#line 633 "../lib/sudoku-board.vala"
	g_free (self);
#line 6295 "sudoku-board.c"
}

static GType
coord_get_type_once (void)
{
	GType coord_type_id;
	coord_type_id = g_boxed_type_register_static ("Coord", (GBoxedCopyFunc) coord_dup, (GBoxedFreeFunc) coord_free);
	return coord_type_id;
}

GType
coord_get_type (void)
{
	static volatile gsize coord_type_id__once = 0;
	if (g_once_init_enter (&coord_type_id__once)) {
		GType coord_type_id;
		coord_type_id = coord_get_type_once ();
		g_once_init_leave (&coord_type_id__once, coord_type_id);
	}
	return coord_type_id__once;
}

void
cell_init (Cell *self,
           Coord* coord,
           gint val)
{
	Coord _tmp0_;
#line 660 "../lib/sudoku-board.vala"
	g_return_if_fail (coord != NULL);
#line 660 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Cell));
#line 662 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 662 "../lib/sudoku-board.vala"
	(*self).coord = _tmp0_;
#line 663 "../lib/sudoku-board.vala"
	(*self).val = val;
#line 6334 "sudoku-board.c"
}

gint
cell_hash (Cell* cell)
{
	Cell _tmp0_;
	Coord _tmp1_;
	Cell _tmp2_;
	gint result;
#line 666 "../lib/sudoku-board.vala"
	g_return_val_if_fail (cell != NULL, 0);
#line 668 "../lib/sudoku-board.vala"
	_tmp0_ = *cell;
#line 668 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_.coord;
#line 668 "../lib/sudoku-board.vala"
	_tmp2_ = *cell;
#line 668 "../lib/sudoku-board.vala"
	result = (coord_hash (&_tmp1_) * 33) ^ _tmp2_.val;
#line 668 "../lib/sudoku-board.vala"
	return result;
#line 6356 "sudoku-board.c"
}

gboolean
cell_equal (Cell* a,
            Cell* b)
{
	gboolean _tmp0_ = FALSE;
	Cell _tmp1_;
	Coord _tmp2_;
	Cell _tmp3_;
	Coord _tmp4_;
	gboolean result;
#line 671 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 671 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 673 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 673 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_.coord;
#line 673 "../lib/sudoku-board.vala"
	_tmp3_ = *b;
#line 673 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_.coord;
#line 673 "../lib/sudoku-board.vala"
	if (coord_equal (&_tmp2_, &_tmp4_)) {
#line 6383 "sudoku-board.c"
		Cell _tmp5_;
		Cell _tmp6_;
#line 673 "../lib/sudoku-board.vala"
		_tmp5_ = *a;
#line 673 "../lib/sudoku-board.vala"
		_tmp6_ = *b;
#line 673 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp5_.val == _tmp6_.val;
#line 6392 "sudoku-board.c"
	} else {
#line 673 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 6396 "sudoku-board.c"
	}
#line 673 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 673 "../lib/sudoku-board.vala"
	return result;
#line 6402 "sudoku-board.c"
}

Cell*
cell_dup (const Cell* self)
{
	Cell* dup;
#line 655 "../lib/sudoku-board.vala"
	dup = g_new0 (Cell, 1);
#line 655 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Cell));
#line 655 "../lib/sudoku-board.vala"
	return dup;
#line 6415 "sudoku-board.c"
}

void
cell_free (Cell* self)
{
#line 655 "../lib/sudoku-board.vala"
	g_free (self);
#line 6423 "sudoku-board.c"
}

static GType
cell_get_type_once (void)
{
	GType cell_type_id;
	cell_type_id = g_boxed_type_register_static ("Cell", (GBoxedCopyFunc) cell_dup, (GBoxedFreeFunc) cell_free);
	return cell_type_id;
}

GType
cell_get_type (void)
{
	static volatile gsize cell_type_id__once = 0;
	if (g_once_init_enter (&cell_type_id__once)) {
		GType cell_type_id;
		cell_type_id = cell_get_type_once ();
		g_once_init_leave (&cell_type_id__once, cell_type_id);
	}
	return cell_type_id__once;
}

gchar*
difficulty_category_to_string (DifficultyCategory self)
{
	gchar* result;
#line 688 "../lib/sudoku-board.vala"
	switch (self) {
#line 688 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 6454 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 691 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup (_ ("Unknown Difficulty"));
#line 691 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 691 "../lib/sudoku-board.vala"
			return result;
#line 6463 "sudoku-board.c"
		}
#line 688 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 6467 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 693 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup (_ ("Easy Difficulty"));
#line 693 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 693 "../lib/sudoku-board.vala"
			return result;
#line 6476 "sudoku-board.c"
		}
#line 688 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 6480 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 695 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup (_ ("Medium Difficulty"));
#line 695 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 695 "../lib/sudoku-board.vala"
			return result;
#line 6489 "sudoku-board.c"
		}
#line 688 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 6493 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 697 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup (_ ("Hard Difficulty"));
#line 697 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 697 "../lib/sudoku-board.vala"
			return result;
#line 6502 "sudoku-board.c"
		}
#line 688 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 6506 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 699 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup (_ ("Very Hard Difficulty"));
#line 699 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 699 "../lib/sudoku-board.vala"
			return result;
#line 6515 "sudoku-board.c"
		}
#line 688 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 6519 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 701 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup (_ ("Custom Puzzle"));
#line 701 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 701 "../lib/sudoku-board.vala"
			return result;
#line 6528 "sudoku-board.c"
		}
		default:
		{
#line 703 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 6534 "sudoku-board.c"
		}
	}
}

gchar*
difficulty_category_to_untranslated_string (DifficultyCategory self)
{
	gchar* result;
#line 709 "../lib/sudoku-board.vala"
	switch (self) {
#line 709 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 6547 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 712 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup ("Unknown Difficulty");
#line 712 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 712 "../lib/sudoku-board.vala"
			return result;
#line 6556 "sudoku-board.c"
		}
#line 709 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 6560 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 714 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup ("Easy Difficulty");
#line 714 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 714 "../lib/sudoku-board.vala"
			return result;
#line 6569 "sudoku-board.c"
		}
#line 709 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 6573 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 716 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup ("Medium Difficulty");
#line 716 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 716 "../lib/sudoku-board.vala"
			return result;
#line 6582 "sudoku-board.c"
		}
#line 709 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 6586 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 718 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup ("Hard Difficulty");
#line 718 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 718 "../lib/sudoku-board.vala"
			return result;
#line 6595 "sudoku-board.c"
		}
#line 709 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 6599 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 720 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup ("Very Hard Difficulty");
#line 720 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 720 "../lib/sudoku-board.vala"
			return result;
#line 6608 "sudoku-board.c"
		}
#line 709 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 6612 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 722 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup ("Custom Puzzle");
#line 722 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 722 "../lib/sudoku-board.vala"
			return result;
#line 6621 "sudoku-board.c"
		}
		default:
		{
#line 724 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 6627 "sudoku-board.c"
		}
	}
}

DifficultyCategory
difficulty_category_from_string (const gchar* input)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 730 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label0 = 0;
#line 730 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label1 = 0;
#line 730 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label2 = 0;
#line 730 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label3 = 0;
#line 730 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label4 = 0;
#line 730 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label5 = 0;
#line 6649 "sudoku-board.c"
	DifficultyCategory result;
#line 728 "../lib/sudoku-board.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 730 "../lib/sudoku-board.vala"
	_tmp0_ = input;
#line 730 "../lib/sudoku-board.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 730 "../lib/sudoku-board.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Unknown Difficulty")))) {
#line 730 "../lib/sudoku-board.vala"
		switch (0) {
#line 6661 "sudoku-board.c"
			default:
			{
#line 733 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_UNKNOWN;
#line 733 "../lib/sudoku-board.vala"
				return result;
#line 6668 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Easy Difficulty")))) {
#line 730 "../lib/sudoku-board.vala"
		switch (0) {
#line 6674 "sudoku-board.c"
			default:
			{
#line 735 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 735 "../lib/sudoku-board.vala"
				return result;
#line 6681 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Medium Difficulty")))) {
#line 730 "../lib/sudoku-board.vala"
		switch (0) {
#line 6687 "sudoku-board.c"
			default:
			{
#line 737 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_MEDIUM;
#line 737 "../lib/sudoku-board.vala"
				return result;
#line 6694 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("Hard Difficulty")))) {
#line 730 "../lib/sudoku-board.vala"
		switch (0) {
#line 6700 "sudoku-board.c"
			default:
			{
#line 739 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_HARD;
#line 739 "../lib/sudoku-board.vala"
				return result;
#line 6707 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("Very Hard Difficulty")))) {
#line 730 "../lib/sudoku-board.vala"
		switch (0) {
#line 6713 "sudoku-board.c"
			default:
			{
#line 741 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_VERY_HARD;
#line 741 "../lib/sudoku-board.vala"
				return result;
#line 6720 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("Custom Puzzle")))) {
#line 730 "../lib/sudoku-board.vala"
		switch (0) {
#line 6726 "sudoku-board.c"
			default:
			{
#line 743 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_CUSTOM;
#line 743 "../lib/sudoku-board.vala"
				return result;
#line 6733 "sudoku-board.c"
			}
		}
	} else {
#line 730 "../lib/sudoku-board.vala"
		switch (0) {
#line 6739 "sudoku-board.c"
			default:
			{
#line 745 "../lib/sudoku-board.vala"
				g_warning ("sudoku-board.vala:745: Could not parse difficulty level. Falling back " \
"to Easy difficulty");
#line 746 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 746 "../lib/sudoku-board.vala"
				return result;
#line 6748 "sudoku-board.c"
			}
		}
	}
}

static GType
difficulty_category_get_type_once (void)
{
	static const GEnumValue values[] = {{DIFFICULTY_CATEGORY_UNKNOWN, "DIFFICULTY_CATEGORY_UNKNOWN", "unknown"}, {DIFFICULTY_CATEGORY_EASY, "DIFFICULTY_CATEGORY_EASY", "easy"}, {DIFFICULTY_CATEGORY_MEDIUM, "DIFFICULTY_CATEGORY_MEDIUM", "medium"}, {DIFFICULTY_CATEGORY_HARD, "DIFFICULTY_CATEGORY_HARD", "hard"}, {DIFFICULTY_CATEGORY_VERY_HARD, "DIFFICULTY_CATEGORY_VERY_HARD", "very-hard"}, {DIFFICULTY_CATEGORY_CUSTOM, "DIFFICULTY_CATEGORY_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType difficulty_category_type_id;
	difficulty_category_type_id = g_enum_register_static ("DifficultyCategory", values);
	return difficulty_category_type_id;
}

GType
difficulty_category_get_type (void)
{
	static volatile gsize difficulty_category_type_id__once = 0;
	if (g_once_init_enter (&difficulty_category_type_id__once)) {
		GType difficulty_category_type_id;
		difficulty_category_type_id = difficulty_category_get_type_once ();
		g_once_init_leave (&difficulty_category_type_id__once, difficulty_category_type_id);
	}
	return difficulty_category_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

